
JSB.newAddon = function (mainPath) {
  JSB.require('utils')
  if (!chatAIUtils.checkMNUtilsFolder(mainPath)) {
    Application.sharedInstance().showHUD("MN ChatAI: Please install 'MN Utils' first!",Application.sharedInstance().focusWindow,5)
    return undefined
  }
  JSB.require('webviewController');
  JSB.require('notificationController')
  JSB.require('dynamicController')
  /** @return {MNChatglmClass} */
  const getMNChatglmClass = ()=>self  
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_config")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNChatglm_promptNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_currentPrompt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_toolbar');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_onNewExcerpt');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNChatglm_dynamic');

  var MNChatglmClass = JSB.defineClass(
    'MNChatglm : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        if (typeof MNUtil === 'undefined') {
          Application.sharedInstance().showHUD("MN ChatAI: Please install 'MN Utils' first!",Application.sharedInstance().focusWindow,5)
          return
        }
      try {
        

        let self = getMNChatglmClass()
        self.isNewWindow = false;
        self.textProcessed = false;
        self.dateGetText = Date.now();
        self.dateNow = Date.now();
        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        self.isFirst = true;
        self.linkDetected = false
        chatAIUtils.init()
        chatAIConfig.init()
        chatAIConfig.mainPath = mainPath
        self.addObserver('onPopupMenuOnSelection:', 'PopupMenuOnSelection')
        self.addObserver('onPopupMenuOnNote:', 'PopupMenuOnNote')
        self.addObserver('onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote')
        self.addObserver('onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection')
        self.addObserver('onProcessNewExcerpt:', 'ProcessNewExcerpt')
        self.addObserver('onChatOnNote:', 'chatOnNote')
        self.addObserver('onChatOnQuestion:', 'chatOnQuestion')
        self.addObserver('onCustomChat:', 'customChat')
        } catch (error) {
        MNUtil.showHUD(error)
      }
      },

      sceneDidDisconnect: function () { // Window disconnect 在插件页面关闭插件和删除插件
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        let names = ['PopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote', 'ClosePopupMenuOnSelection','ProcessNewExcerpt','chatOnNote','chatOnQuestion','customChat']
        self.removeObservers(names)
      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (typeof MNUtil === 'undefined') return
      try {
        
        let self = getMNChatglmClass()
        if (!chatAIUtils.chatController) {
          chatAIUtils.initChatAIController()
        }
        chatAIUtils.ensureView(chatAIUtils.chatController.view)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.chatController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.chatController.view)
        // }
        if (!chatAIUtils.notifyController) {
          chatAIUtils.initNotifyController()
          chatAIUtils.notifyController.view.hidden = true
          chatAIUtils.notifyController.view.frame = {x:50,y:50,width:400,height:120}
          chatAIUtils.notifyController.currentFrame = {x:50,y:50,width:400,height:120}
        }
        chatAIUtils.ensureView(chatAIUtils.notifyController.view)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.notifyController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.notifyController.view)
          chatAIUtils.notifyController.webviewResponse.removeFromSuperview()
          chatAIUtils.notifyController.view.addSubview(chatAIUtils.notifyController.webviewResponse)
        // }
        MNUtil.refreshAddonCommands()
        chatAIUtils.chatController.view.hidden = true;
        chatAIUtils.chatController.notebookid = notebookid
        chatAIUtils.currentNotebookId = notebookid
        // if (chatAIUtils.chatController.promptNames.includes(config.currentPrompt)) {
        //   chatAIUtils.chatController.currentPrompt = currentPrompt
        // }
        if (chatAIConfig.getConfig("autoImport")) {
          chatAIConfig.import(false)
        }

        MNUtil.delay(0.2).then(()=>{
          MNUtil.studyView.becomeFirstResponder()
        })
      } catch (error) {
        MNUtil.showHUD(error)
      }
      },
      notebookWillClose: function (notebookid) {
        if (typeof MNUtil === 'undefined') return
        if (chatAIUtils.notifyController.connection) {
          chatAIUtils.notifyController.connection.cancel()
          delete chatAIUtils.notifyController.connection
        }
        // removeObservers(self,['PopupMenuOnSelection','ClosePopupMenuOnSelection','PopupMenuOnNote','ClosePopupMenuOnNote'])
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (typeof MNUtil === 'undefined') return
        if (controller !== MNUtil.studyController) {
          return;
        };
        if (!chatAIUtils.chatController.view.hidden) {
          let studyFrame = MNUtil.studyView.bounds
          let currentFrame = chatAIUtils.chatController.currentFrame
          if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
            currentFrame.x = studyFrame.width-currentFrame.width*0.5              
          }
          if (currentFrame.y >= studyFrame.height) {
            currentFrame.y = studyFrame.height-20              
          }
          chatAIUtils.chatController.view.frame = currentFrame
          chatAIUtils.chatController.currentFrame = currentFrame
        }
        if (!chatAIUtils.notifyController.view.hidden) {
          let currentFrame = chatAIUtils.notifyController.currentFrame
          chatAIUtils.notifyController.view.frame = currentFrame
          
        }
      },

      queryAddonCommandStatus: function () {
        if (typeof MNUtil === 'undefined') return null
        // MNUtil.showHUD("diff: "+(Date.now() - chatAIConfig.exportDate))
        // if ((Date.now() - chatAIConfig.exportDate) > 1000 && chatAIConfig.getConfig("autoImport")) {
        //   chatAIConfig.import(false)
        //   chatAIConfig.exportDate = Date.now()
        // }
        return {
          image: 'logo.png',
          object: self,
          selector: 'toggleAddon:',
          checked: chatAIConfig.config.autoAction
        };
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        chatAIUtils.currentSelection = sender.userInfo.documentController.selectionText;
        self.dateGetText = Date.now();
        self.textProcessed = false
        self.onPopupMenuOnSelectionTime = Date.now()
        let studyFrame = MNUtil.studyView.frame
        let winFrame = MNUtil.parseWinRect(sender.userInfo.winRect)
        let xOffset = sender.userInfo.arrow===1 ? 20: -50
        let yOffset = sender.userInfo.arrow===1 ? -50: -40
        winFrame.x = winFrame.x+xOffset-studyFrame.x
        winFrame.y = winFrame.y+yOffset
        if (winFrame.x < 0) {
          winFrame.x = 0
        }
        if (winFrame.x > studyFrame.width-40) {
          winFrame.x = studyFrame.width-40
        }
        let dynamicFrame = MNUtil.genFrame(winFrame.x, winFrame.y, 40, 40)
        self.checkDynamicController(dynamicFrame)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.dynamicController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.dynamicController.view)
        // }
        chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.currentNoteId = undefined
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,-1,"onSelection")) {
          return
        }
        chatAIUtils.notifyController.noteid = undefined
        chatAIUtils.chatController.ask(chatAIUtils.currentSelection)
        if (self.viewTimer) self.viewTimer.invalidate();
      },
      onClosePopupMenuOnSelection: function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        // MNUtil.showHUD("message")
        if (!MNUtil.checkSender(sender,self.window)) return;// Don't process message from other window

        self.onClosePopupMenuOnSelectionTime = Date.now()
        if (self.onClosePopupMenuOnSelectionTime>self.onPopupMenuOnSelectionTime+300 && !chatAIUtils.dynamicController.onClick) {
          let preOpacity = chatAIUtils.dynamicController.view.layer.opacity
          MNUtil.animate(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = 0
          }).then(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = preOpacity
            chatAIUtils.dynamicController.view.hidden = true
          })
          return
        }
      },
      /**
       * 
       * @param {{userInfo:{noteid:String}}} sender 
       * @returns 
       */
      onProcessNewExcerpt: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!MNUtil.checkSender(sender)) return; // Don't process message from other window
      try {
        let note = MNNote.new(sender.userInfo.noteid)
        let currentNoteId = sender.userInfo.noteid
        self.notShow = false
        if (note.excerptPic) {
          return
        }


        // let comments = note.comments
        // copyJSON(comments)
        let text = await chatAIUtils.getTextForSearch(note)
        chatAIUtils.currentNoteId = currentNoteId
        chatAIUtils.currentSelection = text
        self.dateGetText = Date.now();
        self.textProcessed = false

        if (self.viewTimer) self.viewTimer.invalidate();
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,note.colorIndex,"onNewExcerpt")) {
          return
        }
        if (chatAIConfig.config.newExcerptTagDetection) {
          // let tags = note.tags
          // MNUtil.copyJSON(tags)
          // let tags = chatAIUtils.extractTagsFromNote(note).map(tag=>tag.slice(1))
          let promptKeys = chatAIConfig.config.promptNames
          let promptNames = promptKeys.map(key=>chatAIConfig.prompts[key].title)
          let commonPrompts = chatAIUtils.findCommonElements(note.tags, promptNames)
          if (commonPrompts.length) {
            let firstPrompt = commonPrompts[0]
            note.removeCommentByIndex(0)
            let promptKey = chatAIUtils.findKeyByTitle(chatAIConfig.prompts, firstPrompt)
            chatAIUtils.notifyController.noteid = currentNoteId
            chatAIUtils.chatController.ask(chatAIUtils.currentSelection,promptKey)
          }
          return
        }
        chatAIUtils.notifyController.noteid = currentNoteId
        chatAIUtils.chatController.ask(chatAIUtils.currentSelection)
      } catch (error) {
        MNUtil.showHUD(error)
      }
      },
      onPopupMenuOnNote: async function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        let note = sender.userInfo.note
        let currentNoteId = note.noteId
        chatAIUtils.onPopupMenuOnNoteTime = Date.now()
      try {
        let studyFrame = MNUtil.studyView.frame
        let winFrame = MNUtil.parseWinRect(sender.userInfo.winRect)
        let yOffset = winFrame.width===10?50:25
        let xOffset = winFrame.width===10?winFrame.width+20:winFrame.width
        let dynamicFrame = MNUtil.genFrame(winFrame.x+xOffset-studyFrame.x, winFrame.y-yOffset, 40, 40)
        if (dynamicFrame.y < 10) {
          dynamicFrame.y = 10
        }
        if (dynamicFrame.x > studyFrame.width-40) {
          dynamicFrame.x = studyFrame.width-40
        }
        self.checkDynamicController(dynamicFrame)
        chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
        // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.dynamicController.view)) {
        //   MNUtil.studyView.addSubview(chatAIUtils.dynamicController.view)
        // }
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.currentNoteId = currentNoteId
        // showHUD(currentNoteId)

        let text = await chatAIUtils.getTextForSearch(note)
        chatAIUtils.currentSelection = text
        if (!text) {
          return
        }
        self.dateGetText = Date.now();
        self.textProcessed = false
        if (self.viewTimer) self.viewTimer.invalidate();
        // MNUtil.showHUD("message")
        if (!self.checkShouldProceed(chatAIUtils.currentSelection,note.colorIndex+16,"onNote")) {
          return
        }
        self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = sender.userInfo.note.noteId
        let question = await chatAIUtils.chatController.getQuestion()
        let sameQuestion = false
        if (self.lastQuestion) {
          sameQuestion = (JSON.stringify(question) === JSON.stringify(self.lastQuestion))
        }
        if (!chatAIUtils.notifyController.view.hidden && sameQuestion) {
          return
        }
        self.lastQuestion = await chatAIUtils.chatController.ask(text)
      } catch (error) {
        MNUtil.showHUD("Error in onPopupMenuOnNote: "+error)
      }
      },
      onClosePopupMenuOnNote: async function (sender) {
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
        if (!chatAIUtils.checkSender(sender, self.window)) return; // Don't process message from other window
        if (chatAIUtils.currentNoteId === sender.userInfo.noteid && Date.now()-self.dateGetText < 500) {
          chatAIUtils.notifyController.notShow = true
        }

        self.onClosePopupMenuOnNoteTime = Date.now()
        if (chatAIUtils.currentNoteId === sender.userInfo.noteid && Date.now()-chatAIUtils.onPopupMenuOnNoteTime < 500) {
          self.notShow = true
        }
        // await MNUtil.delay(0.1)
        if (self.onClosePopupMenuOnNoteTime>chatAIUtils.onPopupMenuOnNoteTime+300 && !chatAIUtils.dynamicController.onClick) {
          let preOpacity = chatAIUtils.dynamicController.view.layer.opacity
          MNUtil.animate(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = 0
          }).then(()=>{
            chatAIUtils.dynamicController.view.layer.opacity = preOpacity
            chatAIUtils.dynamicController.view.hidden = true
          })
          return
        }
      },
      onChatOnNote: async function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        let self = getMNChatglmClass()
  // if (!self.response) {
  //   self.response = ""
  // }
  // self.response = self.response+"time:"+Date.now()
  // copy(self.response)
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (chatAIUtils.notifyController.onChat) {
          return
        }
      try {
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.notifyController.called = true
        let currentNoteId = sender.userInfo.noteid
        let note = MNNote.new(currentNoteId)
        chatAIUtils.currentNoteId = currentNoteId
        let text = await chatAIUtils.getTextForSearch(note)
        if (!text) {
          return
        }
        chatAIUtils.currentSelection = text
        self.dateGetText = Date.now();
        self.textProcessed = false
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!chatAIUtils.chatController.view.window) return;
        // self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = note.noteId
        chatAIUtils.notifyController.notifyLoc = chatAIUtils.chatController.notifyLoc
        chatAIUtils.chatController.ask(text)
      } catch (error) {
        MNUtil.showHUD(error)
      }
      },
      onCustomChat: function (sender) {
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
        if (chatAIUtils.notifyController.connection) {
          MNUtil.showHUD("on output")
          return
        }
        // chatAIUtils.copyJSON(sender.userInfo)
        if (sender.userInfo.prompt) {
          let prompt = sender.userInfo.prompt
          let promptKeys = chatAIConfig.config.promptNames
          let promptNames = promptKeys.map(key=>chatAIConfig.prompts[key].title)
          let commonPrompts = chatAIUtils.findCommonElements([prompt], promptNames)
          if (commonPrompts.length) {
            let firstPrompt = commonPrompts[0]
            let promptKey = chatAIUtils.findKeyByTitle(chatAIConfig.prompts, firstPrompt)
            chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
            chatAIUtils.chatController.ask(chatAIUtils.currentSelection,promptKey)
          }
          return
        }else if(sender.userInfo.user){
          let question = [{role:"user",content:sender.userInfo.user}]
          if (sender.userInfo.system) {
            question.unshift({role:"system",content:sender.userInfo.system})
          }
          chatAIUtils.notifyController.customAsk(question)
        }else{
          chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
          chatAIUtils.notifyController.text = chatAIUtils.currentSelection
          chatAIUtils.chatController.ask()
        }
      },
      onChatOnQuestion: function (sender) { // Clicking note
        if (typeof MNUtil === 'undefined') return
        if (self.window!==chatAIUtils.focusWindow) {
          return
        }
      try {
        let self = getMNChatglmClass()
        chatAIUtils.notifyController.notShow = false
        chatAIUtils.notifyController.called = true
        let question = sender.userInfo.question
        chatAIUtils.currentNoteId = undefined
        chatAIUtils.currentSelection = ""
        self.dateGetText = Date.now();
        self.textProcessed = false
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!chatAIUtils.chatController.view.window) return;
        // self.currentTime = Date.now()
        chatAIUtils.notifyController.noteid = undefined
        if (sender.userInfo.model) {
          chatAIConfig.config.currentModel = sender.userInfo.model
        }else{
          chatAIConfig.config.currentModel = chatAIConfig.config.model
        }
        if (/{{knowledge}}/.test(question)) {
          let knowledge = chatAIConfig.knowledge
          if (knowledge && knowledge.trim() != "") {
            question = question.replace('{{knowledge}}',`
以及部分参考翻译
'''
${knowledge}
'''`)
          }else{
            question = question.replace('{{knowledge}}',``)
          }
        }
        // chatAIUtils.notifyController.textviewResponse.text = "I'm thinking..."
        chatAIUtils.notifyController.ask(question)
      } catch (error) {
        showHUD(error)
      }
      },
      toggleAddon: async function (button) {
      try {
      let clickDate = Date.now()
      chatAIUtils.ensureView(chatAIUtils.chatController.view)
      if (button.clickDate && clickDate-button.clickDate<300) {
        let buttonFrame = chatAIUtils.addonBar.frame
        let dynamicFrame
        if (buttonFrame.x <120) {
          dynamicFrame = MNUtil.genFrame(buttonFrame.x+40, buttonFrame.y, 40, 40)
        }else{
          dynamicFrame = MNUtil.genFrame(buttonFrame.x-300, buttonFrame.y, 40, 40)
        }
        // MNUtil.showHUD("double click")
        if (chatAIUtils.dynamicController && !chatAIUtils.dynamicController.view.hidden) {
          // chatAIUtils.dynamicController.view.hidden = true
          await MNUtil.delay(0.2)
        }
          await self.checkDynamicController(dynamicFrame,true,false)
          chatAIUtils.ensureView(chatAIUtils.dynamicController.view)
          // if (!MNUtil.isDescendantOfStudyView(chatAIUtils.dynamicController.view)) {
          //   MNUtil.studyView.addSubview(chatAIUtils.dynamicController.view)
          // }
          await MNUtil.delay(0.1)
          chatAIUtils.refreshCurrent()
          chatAIUtils.dynamicController.openInput()
          chatAIUtils.chatController.hide(chatAIUtils.addonBar.frame)
        // chatAIUtils.dynamicController.setButtonText(names)
      }else{
        button.clickDate = clickDate
        if (!chatAIUtils.addonBar) {
          chatAIUtils.addonBar = button.superview.superview
        }
        if (chatAIUtils.chatController.view.hidden) {
          if (self.isFirst) {
            // Application.sharedInstance().showHUD("first",self.window,2)
            let buttonFrame = chatAIUtils.addonBar.frame
            let width = 375
            if (buttonFrame.x <120) {
              chatAIUtils.chatController.view.frame = {x:buttonFrame.x+40,y:buttonFrame.y,width:width,height:550}
            }else{
              chatAIUtils.chatController.view.frame = {x:buttonFrame.x-width,y:buttonFrame.y,width:width,height:550}
            }
            chatAIUtils.chatController.currentFrame = chatAIUtils.chatController.view.frame
            self.isFirst = false;
          }
          chatAIUtils.chatController.show(chatAIUtils.addonBar.frame)
          // if (!chatAIUtils.notifyController.view.hidden) {
          //   chatAIUtils.notifyController.hide()
          //   chatAIUtils.notifyController.notifyTimer.invalidate()
          // }
          // chatAIUtils.chatController.view.hidden = false
        } else {
            // chatAIUtils.chatController.view.hidden = true;
          chatAIUtils.chatController.hide(chatAIUtils.addonBar.frame)
          // MNUtil.refreshAddonCommands()
          return;
        }
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          MNUtil.studyView.becomeFirstResponder(); // For dismiss keyboard on iOS
        });

        if (!chatAIUtils.chatController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();

      }
      } catch (error) {
        MNUtil.showHUD(error)
      }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: async function () {// Window disconnect 在插件页面关闭插件和删除插件
        if (typeof MNUtil === 'undefined') return
        // try {
        let confirm = await MNUtil.confirm("MN ChatAI: Remove all config?\n删除所有配置？", "")
        if (confirm) {
          MNUtil.showHUD("remove config")
          chatAIConfig.remove("MNChatglm_prompts")
          chatAIConfig.remove("MNChatglm_knowledge")
          chatAIConfig.remove("MNChatglm_config")
          chatAIConfig.remove("MNChatglm_fileId")
          chatAIConfig.remove("MNChatglm_dynamicPrompt")
        }
        // } catch (error) {
        //   showHUD(error)
        // }
      },

      applicationWillEnterForeground: function () {
        // MNUtil.showHUD("message")
        // if (chatAIUtils.chatController && !chatAIUtils.chatController.view.hidden) {
        //   let studyFrame = MNUtil.studyView.bounds
        //   let currentFrame = chatAIUtils.chatController.currentFrame
        //   if (!currentFrame) {
        //     return
        //   }
        //   if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
        //     currentFrame.x = studyFrame.width-currentFrame.width*0.5              
        //   }
        //   if (currentFrame.y >= studyFrame.height) {
        //     currentFrame.y = studyFrame.height-20              
        //   }
        //   chatAIUtils.chatController.view.frame = currentFrame
        //   chatAIUtils.chatController.currentFrame = currentFrame
        // }
      },

      applicationDidEnterBackground: function () {
        // MNUtil.copy("back")
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );
  /**
   * 
   * @param {string} selector 
   * @param {string} name 
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.addObserver = function (selector,name) {
    NSNotificationCenter.defaultCenter().addObserverSelectorName(this, selector, name);
  }
  /**
   * 
   * @param {string[]} names
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.removeObservers = function (names) {
    names.forEach(name=>{
      NSNotificationCenter.defaultCenter().removeObserverName(self, name);
    })
  }
  MNChatglmClass.prototype.getNoteList = function (note) {
    let noteList = []
    if (note.noteTitle) {
      noteList.push(note.noteTitle)
    }
    if (note.excerptText && !note.excerptPic) {
      noteList.push(note.excerptText)
    }
    return noteList.concat(note.comments.filter(comment=>comment.type="TextNote").map(comment=>comment.text))
  };
  MNChatglmClass.prototype.checkShouldProceed = function (text,colorIndex = -1, param = "") {
    if (!chatAIUtils.chatController.view.window || !chatAIConfig.config.autoAction) {
      // MNUtil.showHUD("message1")
      return false;
    }
    if (param !== "" && !chatAIConfig.config[param]) {
      // MNUtil.showHUD("message2")
      return false
    }
    //聊天模式下禁用
    if (chatAIUtils.notifyController.onChat) {
      // MNUtil.showHUD("message3")
      return false
    }
    if (!chatAIUtils.chatController.view.hidden) {
      //网页模式下不会使用API模式
      // MNUtil.showHUD("message4")
      return false
    }
    //如果提供了颜色则根据颜色判断
    if (colorIndex !== -1 && !chatAIConfig.getConfig("colorConfig")[colorIndex]) {
      // showHUD("should prevent")
      // MNUtil.showHUD("message5")
      return false
    }
    if (chatAIConfig.config.ignoreShortText && chatAIUtils.countWords(text) < 10) {
      // MNUtil.showHUD("message"+chatAIUtils.countWords(text))
      // MNUtil.copy(text)
      return false
    }
    return true
  }
  /**
   * 
   * @param {*} dynamicFrame 
   * @this {MNChatglmClass}
   * @returns 
   */
  MNChatglmClass.prototype.checkDynamicController = async function (dynamicFrame,fullWindow = false,animate = true) {
    if (!chatAIUtils.dynamicController) {
      chatAIUtils.initDynamicController()
      chatAIUtils.dynamicController.mainPath = mainPath;
      chatAIUtils.dynamicController.firstFrame = dynamicFrame
      chatAIUtils.dynamicController.view.hidden  = false
      chatAIUtils.dynamicController.view.layer.opacity = 0
    }
    if (!chatAIConfig.config.dynamic) {
      chatAIUtils.dynamicController.view.hidden = true
      return
    }
    if (chatAIUtils.dynamicController.pinned) {
      return
    }
    if (chatAIUtils.dynamicController.view.hidden) {
      chatAIUtils.dynamicController.view.layer.opacity = 0
      chatAIUtils.dynamicController.view.hidden = false
      chatAIUtils.dynamicController.setLayout(dynamicFrame)
    }

    chatAIUtils.dynamicController.onClick = false
    return new Promise((resolve, reject) => {
      if (animate) {
        MNUtil.animate(()=>{
          chatAIUtils.dynamicController.setLayout(dynamicFrame)
          chatAIUtils.dynamicController.view.layer.opacity = 1.0
          if (fullWindow) {
            chatAIUtils.dynamicController.openInput()
            chatAIUtils.dynamicController.pinned = true
          }
        }).then(()=>{
          chatAIUtils.dynamicController.view.hidden = false
          resolve()
        })
      }else{
        chatAIUtils.dynamicController.setLayout(dynamicFrame)
        chatAIUtils.dynamicController.view.layer.opacity = 1.0
        chatAIUtils.dynamicController.view.hidden = false
        if (fullWindow) {
          chatAIUtils.dynamicController.openInput()
          chatAIUtils.dynamicController.pinned = true
        }
        resolve()
      }
    })
  }
  return MNChatglmClass;
};