/** @return {notificationController} */
const getNotificationController = ()=>self
var notificationController = JSB.defineClass('notificationController : UIViewController <NSURLConnectionDelegate>', {
  viewDidLoad: function() {
try {
    let self = getNotificationController()
    self.init()
    self.custom = false;
    self.size = []

    self.funcResponse = ""
    self.response = ''
    self.dynamic = true;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.isLoading = false;
    self.toolbarOn = true;
    self.view.frame = {x:50,y:50,width:(MNUtil.version.type !== "iPhoneOS") ? 419 : 365,height:120}
    self.lastFrame = self.view.frame;
    // self.currentFrame = self.view.frame
    self.history = []
    self.title = "main"
    self.moveDate = Date.now()
    self.notifyLoc = chatAIConfig.config.notifyLoc
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.cornerRadius = 11
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0
    self.view.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0)

    self.notificationView = UIView.new()
    self.notificationView.layer.cornerRadius = 8
    self.notificationView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.notificationView)
    self.notiScroll = UIScrollView.new()
    self.notiScroll.layer.cornerRadius = 8
    self.notiScroll.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.notiScroll.scrollEnabled = true

    self.notificationView.addSubview(self.notiScroll)
    self.createWebviewResponse()
    self.notificationView.addSubview(self.webviewResponse)

    self.createButton("toolbar",undefined,"notificationView")
    self.toolbar.backgroundColor = MNUtil.hexColorAlpha("#727f94",0.0)

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","closeButtonTapped:","toolbar")
    self.screenButton.setImageForState(self.stopImage,0)
    self.screenButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)

    self.createButton("bigbangButton","bigbang:","toolbar")
    self.bigbangButton.setImageForState(self.bigbangImage,0)

    self.createButton("copyButton","copy:","toolbar")
    self.copyButton.setImageForState(self.copyImage,0)

    self.createButton("titleButton","setNoteTitle:","toolbar")
    self.titleButton.setImageForState(self.titleImage,0)

    self.createButton("commentButton","setComment:","toolbar")
    self.commentButton.setImageForState(self.commentImage,0)

    self.createButton("promptButton","changePrompts:","toolbar")
    self.promptButton.setTitleForState("关键词",0)
    self.promptButton.titleLabel.font = UIFont.boldSystemFontOfSize(16);

    self.createButton("locationButton","toggleLocation:","toolbar")
    self.locationButton.setTitleForState(chatAIConfig.config.notifyLoc?' R ':' L ',0)
    // self.locationButton.setTitleForState(" R ")
    self.locationButton.titleLabel.font = UIFont.boldSystemFontOfSize(20);

    self.createButton("aiLinkButton","showAILink:","toolbar")
    self.aiLinkButton.setImageForState(self.aiLinkImage,0)

    self.createButton("reloadButton","reAsk:","toolbar")
    self.reloadButton.setImageForState(self.reloadImage,0)

    self.createButton("chatButton","openChatView:","toolbar")
    self.chatButton.setImageForState(self.chatImage,0)

    self.createButton("aiButton")
    self.aiButton.setImageForState(self.aiImage,0)
    self.aiButton.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  let self = getNotificationController()
    let buttonHeight = 30
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.frame;
    var height   = viewFrame.height

    if (self.onChat) {
    }else{
      viewFrame.x = 0
      viewFrame.y = 0
      self.notificationView.frame = viewFrame;
      viewFrame.width = 400
      viewFrame.height = height-35
      self.notiScroll.frame = viewFrame

      self.webviewResponse.frame = viewFrame
      self.toolbar.frame = MNUtil.genFrame(0, height-30, 400,buttonHeight)
      self.setLayout()
    }

  },
  closeButtonTapped:async function (params) {
  try {
    

    let self = getNotificationController()
    if (self.connection) {
      self.connection.cancel()
      delete self.connection
    }
    await self.hide()
    self.onChat = false
    if (self.chatView) {
      self.chatView.hidden = true
    }
    self.notificationView.hidden = false
    self.webviewResponse.frame = MNUtil.genFrame(0, 0, 400, 85)
    self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
    // chatAIUtils.clearCurrent()
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  bigbang:async function () {
    let self = getNotificationController()
    let text = await self.getTextForAction()
    if (!self.noteid) {
      MNUtil.postNotification("bigbangText",{text:text})
    }else{
      MNUtil.postNotification("bigbangText",{text:text,noteid:self.noteid,url:chatAIUtils.getUrlByNoteId(self.noteid)})
    }
  },
  copy: async function (sender) {
  // let subviews = MNUtil.studyView.superview.subviews
  // MNUtil.showHUD("message"+subviews.length)
  // let frames = subviews.map(view => view.frame)
  // MNUtil.copyJSON(frames)
  // return
  try {
    let self = getNotificationController()
    let text = await self.getTextForAction()
    MNUtil.showHUD("文字已复制")
    if (sender.clickDate && Date.now()-sender.clickDate < 500) {
      if (self.noteid) {
        let config = {content:text}
        let childNote = chatAIUtils.createChildNote(self.noteid, config)
        MNUtil.showHUD("文字已复制")
        await MNUtil.delay(0.5)
        chatAIUtils.focusNoteInMindMapById(childNote.noteId)
      }
      // if (/^".*"$/.test(text)) {
      //   let length = text.length
      //     text = text.slice(1,length-1)
      // }
    }else{
      sender.clickDate = Date.now()
    }
    MNUtil.copy(text)
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  // textViewDidBeginEditing:function (textview) {
  //   self.notifyTimer.invalidate()
  // },
  reAsk:async function (params) {
    // let sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
    // let frameHeight = self.webviewResponse.frame.height
    // MNUtil.showHUD(sizeHeight+":"+frameHeight)
    let self = getNotificationController()
    if (self.connection) {
      MNUtil.showHUD("On output!")
      return
    }
    try {
      
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notShow = false
    self.called = true
    self.response = ""
    self.preFuncResponse = ''
    if (!self.onChat) {
      if (self.currentPrompt === "Dynamic") {
        self.askByDynamic(self.question,0.99)
      }else{
        self.ask(self.question,0.99)
      }
    }else{
      let last = self.history.pop()
      let question = undefined
      while (last.role !== "user") {
        last = self.history.pop()
      }
      question = last.content
      // if (last.role === "user") {
      //   question = last.content
      //   // MNUtil.showHUD(question)
      // }else{
      //   last = self.history.pop()
      //   // question = self.history.pop().content
      // }
      // let md2html = MNUtil.md2html("I'm thinking...")

      // self["assistant"+self.round].loadHTMLStringBaseURL(chatAIUtils.html(md2html,false,false))
      self["assistant"+self.round].loadFileURLAllowingReadAccessToURL(
        NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
        NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
      );
      self["assistant"+self.round].sizeHeight = 50
      self.setChatLayout()
      // self["assistant"+self.round].frame = MNUtil.genFrame(5,5, self.view.frame.width-10, 50)
      self.continueAsk(question)
    }
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  setNoteTitle: async function(sender) {
    let self = getNotificationController()
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return;
    }
    let note = MNUtil.getNoteById(noteid)
    let text = await self.getTextForAction()
    if (sender.clickDate && Date.now()-sender.clickDate < 500) {
      if (/^".*"$/.test(text)) {
        let length = text.length
        MNUtil.undoGrouping(()=>{
          note.noteTitle = text.slice(1,length-1)
        })
      }
    }else{
      sender.clickDate = Date.now()
      MNUtil.undoGrouping(()=>{
        note.noteTitle = text
      })
    }
    // try {
      
    // }catch (error) {
    //   MNUtil.showHUD(error)
    // }
  },
  setComment: async function () {
    let text = await self.getTextForAction()
  try {
    let noteid
    if (self.onChat) {
      noteid = chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined) ?? self.noteid
    }else{
      noteid = self.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    }
    if (!noteid) {
      MNUtil.showHUD("Unavailable")
      return
    }
    let note = MNUtil.getNoteById(noteid)
    MNUtil.undoGrouping(()=>{
      try {
        note.appendMarkdownComment(text.trim())
      } catch (error) {
        note.appendTextComment(text.trim())
      }
    })
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  showAILink: async function () {
    if (!self.noteid) {
      MNUtil.showHUD("Unavailable")
    }
    let text = await self.getTextForAction()
    MNUtil.postNotification("aiLinkOnText",{text:text,noteid:self.noteid})
  },
  changePrompts: function(sender) {
    let self = getNotificationController();
    self.promptButton.setTitleForState(chatAIConfig.prompts[chatAIConfig.currentPrompt].title ,0)
    var commandTable = chatAIConfig.config.promptNames.map(promptName => {
      return {title:chatAIConfig.prompts[promptName].title,object:self,selector:'askWithPrompt:',param:promptName,checked:chatAIConfig.currentPrompt===promptName}
    })
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,200)
  },
  askWithPrompt: async function (prompt) {
    let self = getNotificationController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.askWithPrompt(prompt)
  },
  onResizeGesture:function (gesture) {
    // MNUtil.showHUD("message")
    if (self.notifyTimer) {self.notifyTimer.invalidate()}
    let studyFrameHeight = MNUtil.studyView.frame.height
    let maxHeight = studyFrameHeight-50
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let height = locationToBrowser.y+baseframe.height*0.5
    if (height <= 100) {
      height = 100
    }
    if (height >= maxHeight) {
      height = maxHeight
    }
    if (self.notifyLoc === 0) {
      //  Application.sharedInstance().MNUtil.showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
      //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
      self.view.frame = {x:50,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }else{
      self.view.frame = {x:frame.x,y:50,width:400,height:height}
      self.currentFrame  = self.view.frame
    }
    if (self.onChat) {
      self.chatView.frame = {x:0,y:0,width:400,height:height}
      self.setChatLayout()
    }

  },
  toggleLocation: async function (params) {
    let self = getNotificationController()
    try {
    switch (chatAIConfig.config.notifyLoc) {
      case 1:
        chatAIConfig.config.notifyLoc = 0
        if (self.onChat) {
          self.chatLocation.setTitleForState("Left",0)
          await self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" L ",0)
        }
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Left",0)
        }
        break;
      case 0:
        chatAIConfig.config.notifyLoc = 1
        if (self.onChat) {
          self.chatLocation.setTitleForState("Right",0)
          await self.setChatLayout()
        }else{
          self.locationButton.setTitleForState(" R ",0)
        }
        if (chatAIUtils.chatController.windowLocationButton) {
          chatAIUtils.chatController.windowLocationButton.setTitleForState("Notification: Right",0)
        }
        // self.locationButton.setTitleForState(" R ",0)
        break;
      default:
        break;
    }
    self.show(chatAIConfig.config.notifyLoc)
    chatAIConfig.save('MNChatglm_config')
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  openChatView: async function (params) {
    let self = getNotificationController()
    if (self.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    try {
      

    self.round = 0
    self.heights = {}
    if (self.notifyTimer) {
      self.notifyTimer.invalidate()
    }
    self.notificationView.hidden = true
    self.webviewResponse.hidden = true

    self.onChat = true
    // self.openChatView()
    self.chatView = new UIView(self.view.bounds)
    self.chatView.layer.cornerRadius = 8
    self.chatView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.view.addSubview(self.chatView)
    self.chatToolbar = UIView.new()
    self.chatToolbar.layer.cornerRadius = 8
    self.chatToolbar.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    self.chatView.addSubview(self.chatToolbar)
    self.createButton("closeChatButton","closeButtonTapped:","chatToolbar")
    self.closeChatButton.setImageForState(self.stopImage,0)
    self.closeChatButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    self.resizeGesture0 = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.closeChatButton.addGestureRecognizer(self.resizeGesture0)
    self.resizeGesture0.view.hidden = false
    self.resizeGesture0.addTargetAction(self,"onResizeGesture:")

    self.createButton("sendButton","continueAsk:","chatView")
    self.sendButton.setImageForState(self.sendImage,0)
    self.sendButton.backgroundColor = MNUtil.hexColorAlpha("#e06c75",0.8)
    self.creatTextView("userInput","chatView")
    self.userInput.editable = true
    self.userInput.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.userInput.scrollEnabled = true
    self.userInput.bounces = true
    self.createButton("chatLocation","toggleLocation:","chatToolbar")
    self.chatLocation.setTitleForState(chatAIConfig.config.notifyLoc?'Right':'Left',0)
    self.chatLocation.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.createButton("chatToken","doNothing:","chatToolbar")
    self.createButton("reAskButton","reAsk:","chatToolbar")
    self.reAskButton.setImageForState(self.reloadImage,0)
    self.chatToken.hidden = false
    self.chatToken.setTitleForState(self.token[0]+"("+chatAIUtils.sum(self.token)+")",0)
    self.chatToken.titleLabel.font = UIFont.boldSystemFontOfSize(16);
    self.scrollView = UIScrollView.new()
    self.scrollView.layer.cornerRadius = 8
    self.scrollView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    self.chatView.addSubview(self.scrollView)
    let md2html = MNUtil.md2html(self.lastResponse).trim()
    if (self.preFuncResponse) {
      md2html = `<pre><code class="hljs">${self.preFuncResponse.trim()}</code></pre>`+md2html
      self.preFuncResponse = ''
    }
    // MNUtil.copy(md2html)
    // if (!self.assistant0) {
    // self.assistant0 = self.createWebview("scrollView")
    self.assistant0 = self.createWebviewHtml(md2html,"scrollView")
    self.assistant0.scrollView.bounces = false
    // MNUtil.delay(0.5).then(()=>{
    //   self.setWebviewContent(md2html, false, "assistant0")
    // })
    self.createButton("copyButton0","copy:","scrollView")
    self.copyButton0.setImageForState(self.copyImage,0)
    self.copyButton0.round = 0
    self.copyButton0.backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    self.createButton("titleButton0","setNoteTitle:","scrollView")
    self.titleButton0.setImageForState(self.titleImage,0)
    self.titleButton0.round = 0
    self.titleButton0.backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    self.createButton("commentButton0","setComment:","scrollView")
    self.commentButton0.setImageForState(self.commentImage,0)
    self.commentButton0.round = 0
    self.commentButton0.backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    // }else{
    //   let md2html = marked.parse(self.response)
    //   self.assistant0.loadHTMLStringBaseURL(chatAIUtils.html(md2html))
    //   self.assistant0.hidden = false
    // }
    // self.creatTextView("assistant0","scrollView")
    // self.assistant0.text = self.response
    // self.assistant0.layer.borderColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    var viewFrame = self.view.frame;
    var height   = viewFrame.height
    let studyFrame = MNUtil.studyView.frame
    viewFrame.height = studyFrame.height-50
    self.view.frame = viewFrame
    self.currentFrame = viewFrame
    self.chatView.frame = MNUtil.genFrame(0, 0, viewFrame.width, viewFrame.height)
    // await MNUtil.delay(0.1)
    self.sizeHeight = self.sizeHeight*1.04
    // let sizeHeight = await self.getWebviewHeight("assistant0",0)
    // if (sizeHeight < self.sizeHeight) {
    //   self.sizeHeight = sizeHeight
    // }
    // self.sizeHeight = await self.getWebviewHeight("assistant0")
    // MNUtil.showHUD("height: "+sizeHeight)
    // let size = self.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
    // await MNUtil.delay(0.5)
    // self.assistant0.sizeHeight = sizeHeight
    // self.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, self.sizeHeight)
    // MNUtil.copyJSON(self.assistant0.frame)
    // sizeHeight= await self.getWebviewHeight("assistant0")
    self.setChatLayout()
    // MNUtil.copyJSON(self.history)
    // self.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, sizeHeight)
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  continueAsk: async function (params) {
    if (self.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    self.round = self.round+1
    try {
      
    let text = self.userInput.text.trim()
    self.userInput.text = ""
    self.creatTextView("user"+self.round,"scrollView")
    self["user"+self.round].font = UIFont.systemFontOfSize(16);
    self["user"+self.round].text = text
    self["user"+self.round].layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self["user"+self.round].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.2)
    self["user"+self.round].editable = false
    self["assistant"+self.round] = self.createWebview("scrollView")
    self["assistant"+self.round].first = true
    self["assistant"+self.round].scrollView.bounces = false
    // let md2html = MNUtil.md2html(self.response)
    // self.setWebviewContent(md2html, false, "assistant0")
    // self.creatTextView("assistant"+self.round,"scrollView")
    // self["assistant"+self.round].text = "I'm thinking..."
    // self["assistant"+self.round].layer.borderColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    // self.targetTextview = "assistant"+self.round
    let viewFrame = self.view.frame
    // MNUtil.showHUD("height: "+sizeHeight)
    // let size = self.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
    // await MNUtil.delay(0.5)
    self["assistant"+self.round].sizeHeight = 50
    self["assistant"+self.round].frame = MNUtil.genFrame(5,5, viewFrame.width-10, 50)
    let copyButtonName = "copyButton"+self.round
    self.createButton(copyButtonName,"copy:","scrollView")
    self[copyButtonName].setImageForState(self.copyImage,0)
    self[copyButtonName].round = self.round
    self[copyButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    let titleButtonName = "titleButton"+self.round
    self.createButton(titleButtonName,"setNoteTitle:","scrollView")
    self[titleButtonName].setImageForState(self.titleImage,0)
    self[titleButtonName].round = 0
    self[titleButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    let commentButtonName = "commentButton"+self.round
    self.createButton(commentButtonName,"setComment:","scrollView")
    self[commentButtonName].setImageForState(self.commentImage,0)
    self[commentButtonName].round = 0
    self[commentButtonName].backgroundColor = MNUtil.hexColorAlpha("#aeaeae",0.8)

    self.setChatLayout()
    self.continueAsk(text)
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidBeginEditing:function (textview) {
    // MNUtil.showHUD("begin")
    // self.notifyTimer.invalidate()
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidChange:function (textview) {
    let frame = self.view.frame
    let size = textview.sizeThatFits({width:frame.width-50,height:1000})
    if (size.height < 50) {
      size.height = 50
    }
    if (size.height > 85) {
      size.height = 85
    }
    self.userInput.frame = MNUtil.genFrame(0,frame.height-85, frame.width-50, size.height)
    // MNUtil.showHUD("change:"+JSON.stringify(size))
    
  },
  connectionDidReceiveResponse: async function (connection,response) {
    let self = getNotificationController()
    self.setButtonOpacity(0.5)
    // self.response = ""
    self.funcResponse = ""
    self.originalText = ""
    self.notShow = false
    // self.size = []
    self.func = undefined
    self.tool = {}
    self.preHeight = 0
    self.autoHide = true
    if (!self.onChat) {
      self.sizeHeight = 0
    }
    self.scrollToBottom = false
    self.first = true
    self.onFinish = false
    // chatAIUtils.copyJSON(self.token)

    if (self.onChat) {
      self.setChatLayout()
    }else{
      // self.webviewResponse.loadHTMLStringBaseURL(html("test"))
      self.sizeHeight = await self.getWebviewHeight()
      // self.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
      self.setNotiLayout()
    }
  },

  connectionDidReceiveData: async function (connection,data) {
    let self = getNotificationController()
    try {
    self.textString = MNUtil.data2string(data)
    self.originalText = self.originalText+self.textString
    // MNUtil.copy(self.originalText)
    switch (self.source) {
      case "Claude":
        self.getResponseForClaude(self.textString)
        break;
      case "Gemini":
        self.getResponseForGemini(self.textString)
        break;
      default:
        if (!/data:/.test(self.textString) && self.textString.trim() !=="") {
          if (/chat\.completion\.chunk/.test(self.textString)) {
            return
          }
          MNUtil.showHUD("Error: "+JSON.stringify(JSON.parse(self.textString)))
          MNUtil.copy(self.textString)
          return;
        }
        self.getResponseForChatGPT(self.textString)
        break;
    }
    await self.setResponseText(self.preFuncResponse+self.funcResponse)
    } catch (error) {
      MNUtil.copy(self.originalText)
      if (self.source !== "Gemini") {
        MNUtil.showHUD("Error in error connectionDidReceiveData: "+error)
      }
    }

    if (/data:\s?\[DONE\]/.test(self.textString)) {
      if (!self.onFinish && self.connection && (self.connection === connection)) {
        self.onFinish = true
        // self.beginTime = Date.now()
        self.prepareFinish()
        // MNUtil.showHUD("finish")
        // MNUtil.copy(self.textString)
      }
    }else{
      if (self.onChat) {
        self.setChatLayout()
      }else{
        self.setNotiLayout()
      }
    }
    return
  },
  connectionDidFinishLoading: function (connection) {
  // let self = getNotificationController()
  if (!self.onFinish && self.connection && (self.connection === connection)) {
    self.onFinish = true
    self.prepareFinish()
    // MNUtil.showHUD("finish")
    // MNUtil.copy(self.textString)
  }
  },
  connectionDidFailWithError: function (connection,error) {
    MNUtil.copyJSON(error.userInfo)
    MNUtil.showHUD("Network error")
    self.setButtonOpacity(1.0)
    delete self.connection
  }
});

notificationController.prototype.preCheck = function () {
  if (this.connection) {
    MNUtil.showHUD("on output")
    return false
  }
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return false
  }
  if (chatAIConfig.config.source === "Built-in") {
    let usage = chatAIConfig.getUsage()
    if (usage.usage >= usage.limit) {
      MNUtil.showHUD("Access limited")
      return false
    }else{
      usage.usage = usage.usage+1
    }
    if (chatAIUtils.chatController.usageButton) {
      chatAIUtils.chatController.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }
  }
  return true
}
/** @this {notificationController} */
notificationController.prototype.askBaseFunc = async function(temperature=0.8,funcIndices=[],custom=false) {
try {
  // chatAIUtils.copyJSON(this.token)
  let source = chatAIConfig.config.source
  let model = chatAIConfig.getDefaultModel()
  let config = chatAIConfig.config

  if (!custom && this.currentPrompt !== "Dynamic") {
    let promptModel = chatAIConfig.prompts[this.currentPrompt].model
    if (promptModel) {
      let modelConfig = promptModel.split(":")
      if (modelConfig[0] !== "Default") {
        source = modelConfig[0]
        // MNUtil.showHUD("Source:"+source)
        if (modelConfig.length === 2) {
          model = modelConfig[1]
        }
        // copyJSON(modelConfig)
      }
    }
  }

  // return
  this.source = source
  // MNUtil.showHUD(source)
  // let askConfig = {}
  // this.baseAsk(this.question,)
  let url
  let apiKey
  switch (source) {
    case "ChatGLM":
      this.initRequestForChatGLM(config.apikey,model,temperature,funcIndices)
      break;
    case "KimiChat":
      url = "https://api.moonshot.cn/v1/chat/completions"
      this.initRequestForChatGPT(config.moonshotKey,url,model,temperature,funcIndices)
      break;
    case "ChatGPT":
      apiKey = config.openaiKey
      url = config.url+`/v1/chat/completions`
      this.initRequestForChatGPT(apiKey, url,model,temperature,funcIndices)
      break;
    case "Custom":
      apiKey = config.customKey
      url = config.customUrl
      this.initRequestForChatGPT(apiKey, url,model,temperature,funcIndices)
      break;
    case "Claude":
      // MNUtil.showHUD("Claude")
      url = config.claudeUrl+"/v1/messages"
      apiKey = config.claudeKey
      // let model = "claude-3-haiku-20240307"
      this.initRequestForClaude(apiKey, url, model, temperature)
      break;
    case "Gemini":
      url = chatAIConfig.getConfig("geminiUrl")
      apiKey = config.geminiKey
      // MNUtil.showHUD(model)
      this.initRequestForGemini(apiKey, url, model, temperature)
      break;
    case "Built-in":
      //对内置模型而言，只能使用选择好的渠道，不能指定模型
      let keyInfo = chatAIConfig.keys["key"+chatAIConfig.config.tunnel]
      if (!keyInfo || !keyInfo.keys) {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      let key = chatAIUtils.getRandomElement(keyInfo.keys)
      if (!key) {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      this.initRequestForChatGPT(key, keyInfo.url,keyInfo.model,temperature,funcIndices)
    default:
      break;
  }
  chatAIUtils.lastTime = Date.now()
} catch (error) {
  MNUtil.showHUD(error)
}
}

/** 
 * @this {notificationController} 
 * @param {{key:String,url:String,model:String}} config
 */
notificationController.prototype.baseAsk = async function(
  question,
  config = chatAIConfig.getConfigFromSource(),  
  temperature=0.8
) {
try {
  // chatAIUtils.copyJSON(config)
  this.question = question
  this.history = [].concat(question)
  this.config = config
  this.temperature = temperature
  this.funcIndices = config.func ?? []
  this.source = config.source
  switch (config.source) {
    case "ChatGLM":
      this.initRequestForChatGLM(config.key,config.model,this.temperature,this.funcIndices)
      break;
    case "KimiChat":
      this.initRequestForChatGPT(config.key,config.url,config.model,this.temperature,[])
      break;
    case "ChatGPT":
      this.initRequestForChatGPT(config.key,config.url,config.model,temperature,this.funcIndices)
      break;
    case "Custom":
      this.initRequestForChatGPT(config.key,config.url,config.model,temperature,this.funcIndices)
      break;
    case "Claude":
      this.initRequestForClaude(config.key,config.url,config.model, temperature)
      break;
    case "Gemini":
      this.initRequestForGemini(config.key,config.url,config.model, temperature)
      break;
    case "Built-in":
      //对内置模型而言，只能使用选择好的渠道，不能指定模型
      let keyInfo = chatAIConfig.keys["key"+chatAIConfig.getConfig("tunnel")]
      if (!keyInfo || !keyInfo.keys) {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      let key = chatAIUtils.getRandomElement(keyInfo.keys)
      if (key === "") {
        MNUtil.showHUD("No apikey for built-in mode!")
        return
      }
      this.initRequestForChatGPT(key, keyInfo.url,keyInfo.model,temperature,this.funcIndices)
    default:
      break;
  }
  chatAIUtils.lastTime = Date.now()
} catch (error) {
  MNUtil.showHUD(error)
}
}

/** 
 * @this {notificationController} 
 * @param {String} prompt
 */
notificationController.prototype.askWithPrompt = async function (prompt) {
  try {
    let config = chatAIConfig.getConfigFromPrompt(prompt)
    let question = await chatAIUtils.chatController.getQuestion(prompt)
    if (!question) {
      return
    }
    // copyJSON(config)
    this.baseAsk(question,config)
    this.beginNotification(config.title)
  } catch (error) {
    MNUtil.showHUD(error)
  }
}
/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.ask = async function(question,temperature=0.8,config={}) {
try {
  // let funcIndices =  chatAIConfig.prompts[this.currentPrompt].func ? chatAIConfig.prompts[this.currentPrompt].func : []
  // copy(funcIndices)
  // if (!this.response) {
  //   this.response = ""
  // }
  // this.response = this.response+"time:"+Date.now()
  // copy(this.response)
  this.dynamic = false
  this.token = []
  this.func = []
  this.preFuncResponse = ""
  // this.targetTextview = "textviewResponse"
  // let config = chatAIConfig.config
  // let controller = this
  let delay = chatAIConfig.config.delay
  if (this.called) {
    delay = 0
  }
  if (!this.preCheck()) {
    return
  }
  await this.delay(delay)
  await this.beginNotification()
  // this.question = question
  // this.apikey = config.apikey
  // this.history = [].concat(question)
  // this.askBaseFunc(temperature,funcIndices)

  let config = chatAIConfig.getConfigFromPrompt()
  this.baseAsk(question,config,temperature)

} catch (error) {
  MNUtil.showHUD(error)
}
  // })
  
};


/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.customAsk = async function(question,noteId = undefined) {
try {
  this.noteid = noteId
  this.token = []
  this.func = []
  this.preFuncResponse = ""
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Toolbar")
  this.question = question
  this.baseAsk(question)
} catch (error) {
  MNUtil.showHUD(error)
}
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.askByDynamic = async function(question,temperature=0.8,reask=false) {
try {
  let config = chatAIConfig.getDynmaicConfig()
  // chatAIUtils.copyJSON(question)
  this.dynamic = true
  this.history = []
  this.token = []
  this.preFuncResponse = ""
  // this.targetTextview = "textviewResponse"
  if (!this.preCheck()) {
    return
  }
  let currentFrame = this.view.frame
  currentFrame.height = 120
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
  await this.beginNotification("Dynamic")
  this.baseAsk(question,config,undefined)
  // chatAIUtils.copyJSON(config)
  // this.askBaseFunc(temperature,config.func)
} catch (error) {
  MNUtil.showHUD(error)
}
  // })
  
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAsk = function(question,temperature=0.8) {
  let config = chatAIConfig.config
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return
  }
  if (this.connection) {
    MNUtil.showHUD("on output")
    return
  }
  let funcIndices
  if (this.dynamic) {
    funcIndices =  chatAIConfig.config.dynamicFunc
  }else{
    funcIndices =  chatAIConfig.prompts[this.currentPrompt].func ? chatAIConfig.prompts[this.currentPrompt].func : []
  }
  this.question = question
  this.apikey = config.apikey
  this.func = []
  // this.history = this.history.concat(question)
  this.history.push({role: "user", content: question})
  // MNUtil.copyJSON(this.history)
  this.askBaseFunc(temperature,funcIndices)
};

/**
 * 
 * @param {*} question 
 * @param {*} temperature 
 * @param {*} reask 
 * @this {notificationController}
 */
notificationController.prototype.continueAfterToolCall = function(temperature=0.8) {
  try {
    
  let config = chatAIConfig.config
  if (this.notShow && !this.called) {
    // MNUtil.showHUD("not show")
    return
  }
  if (this.connection) {
    MNUtil.showHUD("on output")
    return
  }
  let funcIndices
  // config = chatAIConfig.getConfigFromPrompt(this.currentPrompt)
  if (this.dynamic) {
    funcIndices =  chatAIConfig.config.dynamicFunc
  }else{
    funcIndices =  chatAIConfig.prompts[this.currentPrompt].func ? chatAIConfig.prompts[this.currentPrompt].func : []
  }
  this.apikey = config.apikey
  this.func = []
  
  // this.baseAsk(this.history,config,undefined,config.func)
  this.askBaseFunc(temperature,funcIndices)
  } catch (error) {
    MNUtil.showHUD("Error in continueAfterToolCall: "+error)
  }
};
/**
 * @this {notificationController}
 */
notificationController.prototype.prepareFinish = async function () {
  try {
  delete this.connection
  // this.size.push(Date.now())
  this.onFinish = true
  this.scrollToBottom = false
  if (/error/.test(this.textString) && chatAIUtils.isValidJSON(this.textString)) {
    MNUtil.showHUD("Error: "+JSON.stringify(JSON.parse(this.textString)))
    // copy(this.textString)
    if (this.onChat) {
      this.setChatLayout()
    }else{
      this.setNotiLayout()
    }
    this.setButtonOpacity(1.0)
    // delete this.connection
    return
  }
  if (this.source === "ChatGLM") {
    // MNUtil.copy(this.textString)
    let tokens = this.textString.split(`"total_tokens":`)
    let token = tokens[1].split("}")[0]
    // let test = {tokenPre:JSON.stringify(this.token)}
    this.token.push(Number(token))
    // test.tokenPost = JSON.stringify(this.token)
    // chatAIUtils.copyJSON(test)
    this.setToken(token)
  }
    if (!this.func || !this.func.length) {
      this.setButtonOpacity(1.0)
    }
    this.finish()
  } catch (error) {
    MNUtil.showHUD("Error in connectionDidFinishLoading: "+error)
  }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.finish = async function() {
  // this.connection.cancel()
  // MNUtil.copyJSON(this.size)
try {
  this.tool = []
  // MNUtil.copyJSON(this.func)
  if (this.func && this.func.length) {
    // if (this.func.length > 1) {
      // MNUtil.copyJSON(this.tool)
    // }
    // MNUtil.showHUD("message"+this.func.length)
    // copyJSON(this.resList)
    // copy(this.originalText)
    //把得到的func执行一遍并将响应添加到this.tool中
    this.funcResponses = this.func.map(func=> this.executeFunctionByAI(func))
    this.funcResponse = this.funcResponses.join("")
    this.history.push({role:"assistant",tool_calls:this.func})
    this.tool.map(tool=>{this.history.push(tool)})
    // chatAIUtils.copyJSON(this.history)
    this.preFuncResponse = this.preFuncResponse+this.funcResponse
    // copy(this.preFuncResponse)
    if (this.func.map(func=>func.function.name).includes("close")) {
      // await this.delay(0.5)
      // MNUtil.showHUD("close")
      await this.hide()
      this.onChat = false
      if (this.chatView) {
        this.chatView.hidden = true
      }
      this.notificationView.hidden = false
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, 400, 85)
      this.sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`))
    }else{
      this.continueAfterToolCall()
    }
  }else{
    this.funcResponse = ""
    this.lastResponse = this.response
    this.history.push({role:"assistant",content:this.response})
    this.response = ""
    if (this.source !== "ChatGLM") {
      // MNUtil.showHUD("get token")
      await this.getTokens()
    }
  }
  if (this.onChat) {
    this.setChatLayout()
  }else{
    this.sizeHeight = await this.getWebviewHeight()
    // MNUtil.copy("text"+this.sizeHeight)
    this.setNotiLayout()
  }
  this.called = false
  this.onFinish = false

  // this.openChatView()
  // if (this.onChat || !this.autoHide) {
  //   return
  // }
  // let controller = this
  // this.notifyTimer = NSTimer.scheduledTimerWithTimeInterval(10, false, async function () {
  //   controller.hide()
  //   controller.notifyTimer.invalidate()
  //   controller.webviewResponse.loadHTMLStringBaseURL(html("..."))
  //   this.sizeHeight = parseInt(await self.runJavaScript(`document.body.scrollHeight`))
  // })
} catch (error) {
  MNUtil.showHUD("Error in finish: "+error)
  MNUtil.copy(this.textString)
}
}

notificationController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  // MNUtil.showHUD("message")
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.bigbangImage = MNUtil.getImage(chatAIConfig.mainPath + `/bigbang.png`)
  this.copyImage = MNUtil.getImage(chatAIConfig.mainPath + `/copy.png`)
  this.titleImage = MNUtil.getImage(chatAIConfig.mainPath + `/title.png`)
  this.tagImage = MNUtil.getImage(chatAIConfig.mainPath + `/tag.png`)
  this.commentImage = MNUtil.getImage(chatAIConfig.mainPath + `/comment.png`)
  this.aiImage = MNUtil.getImage(chatAIConfig.mainPath + `/ai.png`, 3)
  this.aiLinkImage = MNUtil.getImage(chatAIConfig.mainPath + `/aiLink.png`)
  this.chatImage = MNUtil.getImage(chatAIConfig.mainPath + `/chat.png`)
  this.sendImage = MNUtil.getImage(chatAIConfig.mainPath + `/send.png`)
  this.lockImage = MNUtil.getImage(chatAIConfig.mainPath + `/lock.png`)
  this.unlockImage = MNUtil.getImage(chatAIConfig.mainPath + `/unlock.png`)



}
/**
 * @this {notificationController}
 */
notificationController.prototype.setChatLayout = async function () {
  try {
  let viewFrame = this.chatView.frame
  // MNUtil.showHUD(JSON.stringify(viewFrame))
  // MNUtil.showHUD(JSON.stringify(this.view.frame))
  // MNUtil.showHUD(JSON.stringify(this.aiButton.frame))
  // this.aiButton.frame
  this.chatToolbar.frame = MNUtil.genFrame(0, viewFrame.height-30, viewFrame.width, viewFrame.height)
  this.userInput.frame = MNUtil.genFrame(0,viewFrame.height-85, viewFrame.width-50, 50)
  this.sendButton.frame = MNUtil.genFrame(viewFrame.width-45,viewFrame.height-85, 45, 50)
  this.scrollView.frame = MNUtil.genFrame(0, 0, viewFrame.width, viewFrame.height-90)
  let sizeHeight = this.sizeHeight
  // let size = this.assistant0.sizeThatFits({width:viewFrame.width-10,height:1000})
  // let sizeHeight = this.assistant0.frame.height
  // let testHeight = this.assistant0.sizeHeight
  // if (sizeHeight !== testHeight) {
  //   sizeHeight = await self.getWebviewHeight("assistant0")
  //   if (sizeHeight > testHeight) {
  //     sizeHeight = testHeight
  //   }
    this.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, sizeHeight)
    this.heights.assistant0 = this.assistant0.frame
    this.copyButton0.frame = MNUtil.genFrame(5,sizeHeight+10, 30, 30)
    this.titleButton0.frame = MNUtil.genFrame(40,sizeHeight+10, 30, 30)
    this.commentButton0.frame = MNUtil.genFrame(75,sizeHeight+10, 30, 30)
  //   this.assistant0.sizeHeight = sizeHeight
  //   MNUtil.showHUD("frameHeight:"+sizeHeight+";sizeHeight:"+testHeight)
  // }
  
  // let sizeHeight = await this.getWebviewHeight("assistant0")
  switch (chatAIConfig.config.notifyLoc) {
    case 0:
      this.aiButton.frame = MNUtil.genFrame(-45,0,40,40)
      this.closeChatButton.frame = MNUtil.genFrame(viewFrame.width-30, 0, 30, 30)
      this.reAskButton.frame = MNUtil.genFrame(viewFrame.width-65, 0, 30, 30)
      this.chatLocation.frame = MNUtil.genFrame(0,0,55,30)
      this.chatToken.frame = MNUtil.genFrame(60, 0, 100, 30)
      break;
    case 1:
      this.aiButton.frame = MNUtil.genFrame(viewFrame.width+5,0,40,40)
      this.chatLocation.frame = MNUtil.genFrame(viewFrame.width-55,0,55,30)
      this.reAskButton.frame = MNUtil.genFrame(35, 0, 30, 30)
      this.closeChatButton.frame = MNUtil.genFrame(0, 0, 30, 30)
      this.chatToken.frame = MNUtil.genFrame(viewFrame.width-160, 0, 100, 30)
      break;
    default:
      break;
  }
  let initY = sizeHeight+45
  for (let i = 0; i < this.round; i++) {
    this["assistant"+i].frame = this.heights["assistant"+i]
  }
  if (this["user"+this.round]) {
    let userSize = this["user"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    // MNUtil.showHUD("Usersize:"+JSON.stringify(userSize))
    let assitSize = this["assistant"+this.round].frame.height
    let testHeight = this["assistant"+this.round].sizeHeight
    if (this["assistant"+this.round].first) {
      assitSize = 50
      this["assistant"+this.round].first = false
    }else{
      if (assitSize !== testHeight) {
        assitSize = await this.getWebviewHeight("assistant"+this.round)
        if (assitSize > testHeight) {
          assitSize = testHeight
        }
        this["assistant"+this.round].sizeHeight = assitSize
        // MNUtil.showHUD("frameHeight:"+assitSize+";sizeHeight:"+testHeight)
      }
    }
    // MNUtil.showHUD("message"+assitSize)
    // let assitSize = this["assistant"+this.round].sizeThatFits({width:viewFrame.width-10,height:1000})
    // if (this.preRound == this.round && assitSize == this.preHeight) {
    //   // this.show("return")
    //   return
    // }
    let preFrame = this.heights["assistant"+(this.round-1)]
    // let preFrame = this["assistant"+(this.round-1)].frame
    initY = preFrame.y+preFrame.height+40
    if (userSize.width > 350) {
      this["user"+this.round].frame = MNUtil.genFrame(5,initY, viewFrame.width-10, userSize.height)
    }else{
      this["user"+this.round].frame = MNUtil.genFrame(viewFrame.width-userSize.width-10,initY, userSize.width+5, userSize.height)
    }
    initY = initY+userSize.height+5
    this.heights["assistant"+this.round] = MNUtil.genFrame(5,initY, viewFrame.width-10, assitSize)
    // this["assistant"+this.round].frame = MNUtil.genFrame(5,initY, viewFrame.width-10, assitSize)
    this["assistant"+this.round].frame = this.heights["assistant"+this.round]
    this['copyButton'+this.round].frame = MNUtil.genFrame(5,initY+assitSize+5, 30, 30)
    this['titleButton'+this.round].frame = MNUtil.genFrame(40,initY+assitSize+5, 30, 30)
    this['commentButton'+this.round].frame = MNUtil.genFrame(75,initY+assitSize+5, 30, 30)
    // if (this["assistant"+this.round].frame.y < 100) {
    //   MNUtil.showHUD("message")
    // }
    // MNUtil.copyJSON(this["assistant"+this.round].frame)
    initY = initY+assitSize+40
    this.preHeight = assitSize
  }
  this.preRound = this.round
  this.scrollView.contentSize = {width:400,height:initY+5}
  // this.assistant0.frame = MNUtil.genFrame(5,5, viewFrame.width-10, sizeHeight)
  // MNUtil.showHUD("inity:"+initY)
  if (initY > viewFrame.height-95) {
    this.scrollView.setContentOffsetAnimated({x:0,y:initY-viewFrame.height+95},true)
  }
  } catch (error) {
    MNUtil.showHUD("Error in setChatLayout: "+error)
  }
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setNotiLayout = async function () {
  let sizeHeight = this.sizeHeight
  // MNUtil.showHUD("message"+sizeHeight)
  if (!sizeHeight) {
    // MNUtil.showHUD("Invalid height")
    return
  }
  let currentFrame = this.view.frame
  let studyHeight = MNUtil.studyView.frame.height
  if (sizeHeight+35<120) {
    currentFrame.height = 120
      // MNUtil.showHUD('message3:'+sizeHeight)
    // this.size.push({message:'message3',current:currentFrame.height,size:sizeHeight,study:studyHeight})
  }else{
    // if (sizeHeight+35 > currentFrame.height && sizeHeight-currentFrame.height < 100) {
    //   // MNUtil.showHUD("message")
    //   currentFrame.height = sizeHeight+35
    // }else{
    //   // MNUtil.showHUD("diff:"+sizeHeight+":"+currentFrame.height)
    // }
    //超出页面大小，需滚动
    if ((currentFrame.y+sizeHeight+30)>studyHeight) {
      // MNUtil.showHUD('需要滚动')
    // this.size.push({message:'message2',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.scrollToBottom = true
      currentFrame.height = studyHeight-currentFrame.y
      this.autoHide = false
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, 400, currentFrame.height-35)
      // this.webviewResponse.frame = genFrame(0, 0, 400, sizeHeight+30)
      // this.notiScroll.contentSize = {width:400,height:sizeHeight}
      // this.notiScroll.setContentOffsetAnimated({x:0,y:sizeHeight-this.notiScroll.frame.height+30},true)
    }else{
      if (sizeHeight+35 > currentFrame.height) {
        currentFrame.height = sizeHeight+35
      }
      // MNUtil.showHUD('message1')
      // this.size.push({message:'message1',current:currentFrame.height,size:sizeHeight,study:studyHeight})
      this.webviewResponse.frame = MNUtil.genFrame(0, 0, 400, sizeHeight)
    }
  }
  this.view.frame = currentFrame
  this.currentFrame = currentFrame
}
notificationController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(chatAIConfig.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {notificationController}
 */
notificationController.prototype.creatTextView = function (viewName,superview="view",color="#ffffff",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(17);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].editable = true
  this[viewName].scrollEnabled = false
  this[viewName].bounces = false
  this[viewName].layer.borderWidth = 4

  this[superview].addSubview(this[viewName])
}

notificationController.prototype.hideAllButton = function (frame) {
  this.toolbar.hidden = true
}
notificationController.prototype.showAllButton = function (frame) {
  this.toolbar.hidden = false
}
notificationController.prototype.show = function (notifyLoc) {
try {
  
  let studyFrame = MNUtil.studyView.frame
  let height = this.onChat?studyFrame.height-50:120
  this.notifyLoc = notifyLoc
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = 50
      this.view.frame = {x:-300,y:50,width:400,height:height}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width-450
      this.view.frame = {x:studyFrame.width,y:50,width:400,height:height}
      break;
    default:
      break;
  }
  let preFrame = this.currentFrame
  preFrame.width = 400
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
    this.setLayout()
  this.hideAllButton()

  UIView.animateWithDurationAnimationsCompletion(0.3,()=>{
    this.view.layer.opacity = preOpacity
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.setLayout()
  },
  ()=>{
    this.view.layer.borderWidth = 0
    this.showAllButton()
  })
} catch (error) {
  MNUtil.showHUD("Error in show: "+error)
}
}
/**
 * @this {notificationController}
 */
notificationController.prototype.hide = async function () {
  let studyFrame = MNUtil.studyView.bounds
  this.onChat = false
  if (this.connection) {
    this.connection.cancel()
    delete this.connection
  }
  switch (this.notifyLoc) {
    case 0:
      this.currentFrame.x = -this.currentFrame.width
      // this.view.frame = {x:-300,y:10,width:300,height:120}
      break;
    case 1:
      this.currentFrame.x = studyFrame.width
      // this.view.frame = {x:studyFrame.width,y:10,width:300,height:120}
      break;
    default:
      break;
  }
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  // let preFrame = this.view.frame
  this.hideAllButton()
  this.custom = false
  await MNUtil.animate(()=>{
    this.view.layer.opacity = 0.2
    this.view.frame = preFrame}
  )
  this.view.hidden = true;
  this.view.layer.opacity = preOpacity      
  this.view.frame = preFrame
  // this.currentFrame = preFrame
  this.custom = preCustom
  this.response = ''
  this.setResponseText('')
  return


  return new Promise((resolve, reject) => {

  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    this.view.layer.opacity = 0.2
    this.view.frame = preFrame
    // if (frame) {
    //   this.view.frame = frame
    //   this.currentFrame = frame
    // }
    // this.view.frame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
    // this.currentFrame = {x:preFrame.x+preFrame.width*0.1,y:preFrame.y+preFrame.height*0.1,width:preFrame.width*0.8,height:preFrame.height*0.8}
  },
  ()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    // this.currentFrame = preFrame
    this.custom = preCustom
    resolve()
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  })
      
  })
}

/**
 * @this {notificationController}
 */
notificationController.prototype.setLayout = function () {
try {
  var viewFrame = this.toolbar.bounds;
  var width    = viewFrame.width
  var height   = viewFrame.height
  viewFrame.height = viewFrame.height-30
  switch (chatAIConfig.config.notifyLoc) {
    case 0:
      this.aiButton.frame = MNUtil.genFrame(-45,0,40,40)
      this.screenButton.frame = MNUtil.genFrame(width-30,0,30,30)
      this.bigbangButton.frame = MNUtil.genFrame(width-65,0,30,30)
      this.commentButton.frame = MNUtil.genFrame(width-100,0,30,30)
      this.titleButton.frame = MNUtil.genFrame(width-135,0,30,30)
      this.copyButton.frame = MNUtil.genFrame(width-170,0,30,30)
      this.aiLinkButton.frame = MNUtil.genFrame(width-205,0,30,30)
      this.reloadButton.frame = MNUtil.genFrame(width-240,0,30,30)
      this.chatButton.frame = MNUtil.genFrame(width-275,0,30,30)
      this.locationButton.frame = MNUtil.genFrame(90,0,30,30)
      this.promptButton.frame = MNUtil.genFrame(0,0,85,30)
      break;
    case 1:
      this.aiButton.frame = MNUtil.genFrame(width+5,0,40,40)
      this.screenButton.frame = MNUtil.genFrame(0,0,30,30)
      this.bigbangButton.frame = MNUtil.genFrame(35,0,30,30)
      this.commentButton.frame = MNUtil.genFrame(70,0,30,30)
      this.titleButton.frame = MNUtil.genFrame(105,0,30,30)
      this.copyButton.frame = MNUtil.genFrame(140,0,30,30)
      this.aiLinkButton.frame = MNUtil.genFrame(175,0,30,30)
      this.reloadButton.frame = MNUtil.genFrame(210,0,30,30)
      this.chatButton.frame = MNUtil.genFrame(245,0,30,30)
      this.locationButton.frame = MNUtil.genFrame(viewFrame.width-120,0,30,30)
      this.promptButton.frame = MNUtil.genFrame(viewFrame.width-85,0,90,30)
      break;
    default:
      break;
  }
} catch (error) {
  MNUtil.showHUD("setLayout: "+error)
}
}
/** @this {notificationController} */
notificationController.prototype.beginNotification = async function (promptName) {
    // chatAIUtils.ensureView(this.view)
    this.setNewResponse()
    // this.notificationView.hidden = true
    this.webviewResponse.hidden = false
    let currentFrame = this.view.frame
    currentFrame.height = 120
    this.view.frame = currentFrame
    this.currentFrame = currentFrame
    this.locationButton.setTitleForState(chatAIConfig.config.notifyLoc?' R ':' L ',0)
    try {
    if (promptName) {
      this.promptButton.setTitleForState(promptName ,0)
    }else{
      this.promptButton.setTitleForState(chatAIConfig.currentTitle ,0)
    }
    } catch (error) {
      MNUtil.showHUD(error)
    }
    if (this.view.hidden || this.notifyLoc !== chatAIConfig.config.notifyLoc) {
      this.show(chatAIConfig.config.notifyLoc)
    }

    MNUtil.studyView.bringSubviewToFront(this.view)
    if (this.notifyTimer) {
      this.notifyTimer.invalidate()
    }
  }

/** @this {notificationController} */
notificationController.prototype.getTextForAction = async function () {
  if (this.onChat) {
    let round = this.round
    // MNUtil.showHUD("round:"+round)
    let history = this.history.filter(his=>(his.role === "assistant" && !his.tool_calls))
    return history[round].content
    // return this.reponse
    // return "abc"
  }else{
    let selectedText = await this.runJavaScript("getSelectedTextOrPageText()")
    if (selectedText.trim() !== "") {
      return selectedText.trim()
    }
    return this.lastResponse.trim()
  }
}

notificationController.prototype.initRequestForChatGPT = function (apikey,url,model,temperature,funcIndices=[]) {
  if (apikey.trim() === "") {
    MNUtil.showHUD(model+": No apikey!")
    return
  }
  const headers = {
    "Content-Type": "application/json",
    Authorization: "Bearer "+apikey,
    Accept: "text/event-stream"
  }
    // copyJSON(headers)
  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  if (funcIndices.length) {
    let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
    let tools = chatAIUtils.getFunByIndex(funcIndices,noteid)
    if (tools.length) {
      body.tools = tools
    }
  }
  // chatAIUtils.copyJSON(body)
  // copyJSON(body)

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest(url, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
  // MNUtil.showHUD("new connection")
}
notificationController.prototype.initRequestForClaude = function (apikey,url,model,temperature,funcIndices=[]) {
  // if (apikey.trim() === "") {
  //   MNUtil.showHUD("No apikey!")
  //   return
  // }
  try {
    

  const headers = {
    "Content-Type": "application/json",
    "x-api-key":apikey,
    "anthropic-version":"2023-06-01"
  }
  let body = {
    "model":model,
    "max_tokens": 1024,
    "stream":true
  }
  let system = this.history.filter(item => item.role === "system")[0]
  // copyJSON(system)
  if (system) {
    body.system = system.content
    body.messages = this.history.filter(item => item.role !== "system")
  }else{
    body.messages = this.history
  }

  // copyJSON(body)
  const request = chatAINetwork.initRequest(url, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
    } catch (error) {
    MNUtil.showHUD(error)
  }
}
notificationController.prototype.initRequestForGemini = function (apikey,url,model,temperature,funcIndices=[]) {
  // if (apikey.trim() === "") {
  //   MNUtil.showHUD("No apikey!")
  //   return
  // }
  // let fullURL
  // if (model === "gemini-1.5") {
    
  // }
  let fullURL = url+"/v1beta/models/"+model+":streamGenerateContent?key="+apikey
  try {
    

  const headers = {
    "Content-Type": "application/json"
  }
  let body = {
  }
  // let system = this.history.filter(item => item.role === "system")[0]
  // copyJSON(system)
  // if (system) {
  //   body.system = system.content
  //   body.messages = this.history.filter(item => item.role !== "system")
  // }else{
  // let historyWithoutSystem = this.history.filter(item => item.role !== "system")
    // body.contents = this.history
  let system = ""
  let history = []
  this.history.map(his=>{
    if (his.role === "system") {
      system = his.content
      if (model === "gemini-1.5-pro-latest") {
        body.system_instruction = {parts:{text:system}}
        system = ""
      }
      // history.push({role:"system",parts:[{text:his.content}]})
      return
    }
    if (his.role === "user") {
      if (system) {
        history.push({role:"user",parts:[{text:system+"\n"+his.content}]})
        system = ""
      }else{
        history.push({role:"user",parts:[{text:his.content}]})
      }
      return
    }
    if (his.role === "assistant") {
      history.push({role:"model",parts:[{text:his.content}]})
      return
    }
  })
  body.contents = history

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest(fullURL, {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
    } catch (error) {
    MNUtil.showHUD(error)
  }
}

/** 
 * @this {notificationController}
 */
notificationController.prototype.initRequestForChatGLM = function (apikey,model,temperature,funcIndices=[]) {
  if (apikey.trim() === "") {
    MNUtil.showHUD(model+": No apikey!")
    return
  }
  // copy(apikey)
  let final_sign = chatAINetwork.getAuthorization(apikey)    
  const headers = {
    "Content-Type": "application/json",
    Authorization: final_sign
  }
  let body = {
    "model":model,
    "messages":this.history,
    "temperature":temperature,
    "stream":true
  }
  body.tools = [{
    type:"web_search",
    web_search:{enable:false}
  }]
  if (funcIndices.length) {
    let tools = chatAIUtils.getFunByIndex(funcIndices,this.noteid !== undefined)
    body.tools = body.tools.concat(tools)
  }
  // }else{
  // }

  // MNUtil.copyJSON(body)
  const request = chatAINetwork.initRequest("https://open.bigmodel.cn/api/paas/v4/chat/completions", {
      method: "POST",
      headers: headers,
      timeout: 60,
      json: body
    })
  this.currentTime = Date.now()
  this.connection = NSURLConnection.connectionWithRequestDelegate(request,this)
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForChatGPT = function (response) {
  try {

    this.resList = chatAIUtils.getResList(this.originalText)
    // this.resList = chatAIUtils.getResList(testString)
    // copyJSON(resList)
    if (chatAIUtils.checkToolCalls(this.resList)) {

      let funcs = []
      // MNUtil.copyJSON(this.resList)
      this.resList.map(res=>{
        if (res.tool_calls) {
          if (res.tool_calls[0].function.name) {
            funcs.push(res.tool_calls[0])
            // func = res.tool_calls[0]
          }
          funcs[res.tool_calls[0].index].function.arguments = funcs[res.tool_calls[0].index].function.arguments+res.tool_calls[0].function.arguments
          // return delta.tool_calls[0].function.arguments
        }else{
          return ""
        }
      }).join("")
      this.func = []
      this.funcResponses = funcs.map(func=>{
        let arguments = MNUtil.getValidJSON(MNUtil.mergeWhitespace(func.function.arguments))
        func.function.arguments = JSON.stringify(arguments)
        if (arguments) {
          this.func.push(func)
          return this.codifyToolCall(func.function.name, arguments)
        }else{
          func.function.arguments = ""
          this.func.push(func)
          return func.function.name+"()\n"
        }
      })
      this.funcResponse = this.funcResponses.join("")
      
    }else{
      this.response = this.resList.map(res=>{
        if (res && res.content) {
          return res.content
        }
        return ""
      }).join("")
    }
    return
  } catch (error) {
    MNUtil.showHUD("Error in getResponseForChatGPT: "+error)
    // MNUtil.copy(this.originalText)
    return
  }
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForGemini = function (response) {
  try {
    // let res = this.originalText.split("data:")
    // res.shift()
    // res.pop()
    if (!MNUtil.isValidJSON(this.originalText) && !MNUtil.isValidJSON(this.originalText+"]")) {
      return
    }
    try {
      this.resList = JSON.parse(this.originalText).map(res=>{
        return res.candidates[0].content.parts[0].text
      })
    } catch (error) {
      this.resList = JSON.parse(this.originalText+"]").map(res=>{
        return res.candidates[0].content.parts[0].text
      })
    }
    this.response = this.resList.join("")
    return
  } catch (error) {
    MNUtil.showHUD("Error in getResponseForGemini: "+error)
    MNUtil.copy(this.originalText)
    return
  }
}

/** 
 * @param {string} response 
 * @this {notificationController}
 */
notificationController.prototype.getResponseForClaude = function (response) {
  try {
    // let res = this.originalText.split("data:")
    // res.shift()
    // res.pop()

    this.resList = chatAIUtils.parseEvents(this.originalText)
    // copyJSON(this.resList)
    let response = ""

    this.resList.map(res=>{
      if (res.event === "content_block_start") {
        response = res.data.content_block.text
      }
      if (res.event === "content_block_delta") {
        response = response+res.data.delta.text
      }
    })
    // copy(response)
    this.response = response
    return
  } catch (error) {
    MNUtil.showHUD("Error in getResponseForChatGPT: "+error)
    MNUtil.copy(this.originalText)
    return
  }
}
/** 
 * @this {notificationController}
 * 用来格式化调用的函数内容的
 */
notificationController.prototype.codifyToolCall = function (funcName,arguments) {
  switch (funcName) {
    case "multi_tool_use.parallel":
      let preFix = `multi_tool_use(\n`
      let tool_uses = arguments.tool_uses
      let toolMessages = []
      tool_uses.map((tool_use,index)=>{
        switch (tool_use.recipient_name) {
          case "functions.setTitle":
            toolMessages.push("\t"+this.codifyToolCall("setTitle", {title:tool_use.parameters.title.trim()}))
            break;
          case "functions.addComment":
            toolMessages.push("\t"+this.codifyToolCall("addComment", {comment:tool_use.parameters.comment.trim()}))
            break;
          case "functions.addTag":
            toolMessages.push("\t"+this.codifyToolCall("addTag", {tag:tool_use.parameters.tag.trim()}))
            break;
          case "functions.copyMarkdownLink":
            toolMessages.push("\t"+this.codifyToolCall("copyMarkdownLink", {title:tool_use.parameters.title.trim()}))
            break;
          case "functions.copyCardURL":
            toolMessages.push("\t"+this.codifyToolCall("copyCardURL", {}))
            break;
          case "functions.copyText":
            toolMessages.push("\t"+this.codifyToolCall("copyText", {text:tool_use.parameters.text.trim()}))
            break;
          case "functions.addChildNote":
            toolMessages.push("\t"+this.codifyToolCall("addChildNote", {title:tool_use.parameters.title.trim(),content:tool_use.parameters.content.trim()}))
            break;
          case "functions.clearExcerpt":
            toolMessages.push("\t"+this.codifyToolCall("clearExcerpt", {}))
            break;
          case "functions.close":
            toolMessages.push("\t"+this.codifyToolCall("close", {}))
            break;
          case "functions.setExcerpt":
            toolMessages.push("\t"+this.codifyToolCall("setExcerpt", {excerpt:tool_use.parameters.excerpt.trim()}))
            break
          default:
            break;
        }
      })
      return preFix+toolMessages.join("")+")\n"
    case "setTitle":
      if (arguments.title) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.title)}")\n`
      }
    case "addComment":
      if (arguments.comment) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.comment)}")\n`
      }
    case "addTag":
      if (arguments.tag) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.tag)}")\n`
      }
    case "copyMarkdownLink":
      if (arguments.title) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.title)}")\n`
      }
    case "copyCardURL":
      return `${funcName}()\n`
    case "copyText":
      if (arguments.text) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.text)}")\n`
      }
    case "close":
      return `${funcName}()\n`
    case "clearExcerpt":
      return `${funcName}()\n`
    case "setExcerpt":
      if (arguments.excerpt) {
        return `${funcName}("${MNUtil.mergeWhitespace(arguments.excerpt)}")\n`
      }
    case "addChildNote":
      let pre = `${funcName}(\n`
      if (arguments.title) {
        pre = pre+`"${MNUtil.mergeWhitespace(arguments.title)}"`
        if (arguments.content) {
          pre = pre+",\n"
        }
      }
      if (arguments.content) {
        pre = pre+`"${MNUtil.mergeWhitespace(arguments.content)}"`
      }
      pre = pre+`\n)\n`
      return pre
      return `${funcName}(\n"${MNUtil.mergeWhitespace(arguments.title)}",\n"${MNUtil.mergeWhitespace(arguments.content)}\n")\n`
    default:
      break;
  }
  // copyJSON(arguments)
  return "Error"
}

notificationController.prototype.openChatView = function (params) {
    if (this.connection) {
      MNUtil.showHUD("Wait...")
      return
    }
    // this.round = 0
    // if (this.notifyTimer) {
    //   this.notifyTimer.invalidate()
    // }
    // this.notificationView.hidden = true
    // this.onChat = true
    this.chatView = new UIView(this.view.bounds)
    this.chatView.layer.cornerRadius = 8
    this.chatView.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.0)
    this.view.addSubview(this.chatView)
}
notificationController.prototype.delay = async function (seconds) {
  return new Promise((resolve, reject) => {
    NSTimer.scheduledTimerWithTimeInterval(seconds, false, function () {
      resolve()
    })
  })
}
notificationController.prototype.createTextviewResponse  = function () {
  this.textviewResponse = UITextView.new()
  this.textviewResponse.font = UIFont.systemFontOfSize(16);
  this.textviewResponse.layer.cornerRadius = 8
  this.textviewResponse.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
  this.textviewResponse.textColor = UIColor.blackColor()
  this.textviewResponse.delegate = this
  this.textviewResponse.contentSize = {width:400,height:120}
  this.textviewResponse.scrollEnabled = false
  this.textviewResponse.text = `Loading...`
}
notificationController.prototype.createWebviewResponse = function () {
  try {
    
  this.webviewResponse = new UIWebView(this.view.bounds);
  this.webviewResponse.backgroundColor = UIColor.whiteColor();
  this.webviewResponse.scalesPageToFit = false;
  this.webviewResponse.autoresizingMask = (1 << 1 | 1 << 4);
  this.webviewResponse.delegate = this;
  // this.webviewResponse.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  this.webviewResponse.scrollView.delegate = this;
  this.webviewResponse.layer.cornerRadius = 8;
  this.webviewResponse.layer.masksToBounds = true;
  this.webviewResponse.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
  this.webviewResponse.layer.borderWidth = 0
  this.webviewResponse.layer.opacity = 0.9
  this.webviewResponse.scrollView.bounces = false

  // this.webviewResponse.loadFileURLAllowingReadAccessToURL(
  //   NSURL.fileURLWithPath(this.mainPath + '/test.html'),
  //   NSURL.fileURLWithPath(this.mainPath + '/')
  // );
  // this.webviewResponse.loadHTMLStringBaseURL(chatAIUtils.html(`Loading...`))
  this.webviewResponse.loadFileURLAllowingReadAccessToURL(
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
  );
    } catch (error) {
    MNUtil.showHUD(error)
  }
}
/** 
 * @this {notificationController}
 */
notificationController.prototype.createWebview = function (superview) {
  try {
  let webview = new UIWebView(this.view.bounds);
  webview.backgroundColor = UIColor.whiteColor();
  webview.scalesPageToFit = false;
  webview.autoresizingMask = (1 << 1 | 1 << 4);
  webview.delegate = this;
  // webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  webview.scrollView.delegate = this;
  webview.layer.cornerRadius = 8;
  webview.layer.masksToBounds = true;
  webview.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
  webview.layer.borderWidth = 0
  webview.layer.opacity = 0.9
  // webview.loadFileURLAllowingReadAccessToURL(
  //   NSURL.fileURLWithPath(this.mainPath + '/test.html'),
  //   NSURL.fileURLWithPath(this.mainPath + '/')
  // );
  // let md2html = marked.parse(content)
  // let md2html = MNUtil.md2html(content)
  // webview.loadHTMLStringBaseURL(chatAIUtils.html(md2html,false,false))
  webview.loadFileURLAllowingReadAccessToURL(
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
    NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
  );
  // let height = this.setWebviewContent(md2html, false, webview)
  if (superview) {
    this[superview].addSubview(webview)
  }else{
    this.view.addSubview(webview)
  }
  return webview
    } catch (error) {
    MNUtil.showHUD(error)
  }
}
/** 
 * @this {notificationController}
 */
notificationController.prototype.createWebviewHtml = function (content,superview) {
  try {
  let webview = new UIWebView(this.view.bounds);
  webview.backgroundColor = UIColor.whiteColor();
  webview.scalesPageToFit = false;
  webview.autoresizingMask = (1 << 1 | 1 << 4);
  webview.delegate = this;
  // webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
  webview.scrollView.delegate = this;
  webview.layer.cornerRadius = 8;
  webview.layer.masksToBounds = true;
  webview.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
  webview.layer.borderWidth = 0
  webview.layer.opacity = 0.9
  // webview.loadFileURLAllowingReadAccessToURL(
  //   NSURL.fileURLWithPath(this.mainPath + '/test.html'),
  //   NSURL.fileURLWithPath(this.mainPath + '/')
  // );
  // let md2html = marked.parse(content)
  // let md2html = MNUtil.md2html(content)
  webview.loadHTMLStringBaseURL(chatAIUtils.html(content))
  // webview.loadFileURLAllowingReadAccessToURL(
  //   NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
  //   NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
  // );
  // let height = this.setWebviewContent(md2html, false, webview)
  if (superview) {
    this[superview].addSubview(webview)
  }else{
    this.view.addSubview(webview)
  }
  return webview
    } catch (error) {
    MNUtil.showHUD(error)
  }
}
/** @this {notificationController} */
notificationController.prototype.runJavaScript = async function(script,webview) {
  // if(!this.webviewResponse || !this.webviewResponse.window)return;
  return new Promise((resolve, reject) => {
    try {
      
    if (webview) {
      // MNUtil.copy(webview)
      this[webview].evaluateJavaScript(script,(result) => {resolve(result)});
    }else{
      this.webviewResponse.evaluateJavaScript(script,(result) => {resolve(result)});
    }
    } catch (error) {
      MNUtil.showHUD(error)
      resolve(0)
    }
  })
};
/** @this {notificationController} */
notificationController.prototype.getWebviewHeight = async function (webview,offset = 25) {
  let sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`,webview))+offset
  // let sizeHeight = parseInt(await this.runJavaScript(`Math.min(document.body.scrollHeight, document.body.offsetHeight, document.documentElement.clientHeight, document.documentElement.scrollHeight, document.documentElement.offsetHeight)`,webview))+35
  return sizeHeight
}
/** @this {notificationController} */
notificationController.prototype.setWebviewContent = async function (content,scrollToBottom = false,webview) {
  let height
  if (scrollToBottom) {
    // MNUtil.copy(content)
    // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});document.body.scrollHeight;`,webview)
    height = await this.runJavaScript(`document.body.innerHTML = decodeURIComponent(\`${encodeURIComponent(content)}\`); MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});document.body.scrollHeight;`,webview)
    // MNUtil.copyJSON(height)
    if (!Object.keys(height).length) {
      return await this.getWebviewHeight(webview) 
    }
    // MNUtil.copy(height)
  }else{
    // MNUtil.copy(content)
    // height = await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(content)}"; MathJax.typeset();document.body.scrollHeight;`,webview)
    height = await this.runJavaScript(`document.body.innerHTML = decodeURIComponent(\`${encodeURIComponent(content)}\`); MathJax.typeset();document.body.scrollHeight;`,webview)
    // MNUtil.copyJSON(height)
    if (!Object.keys(height).length) {
      return await this.getWebviewHeight(webview) 
    }
    // MNUtil.copy(height)
  }
  return parseInt(height)+25
}
/** @this {notificationController} */
notificationController.prototype.setNewResponse = function (webview) {
  if (webview) {
    this[webview].loadFileURLAllowingReadAccessToURL(
      NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
      NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
    );
  }else{
    this.webviewResponse.loadFileURLAllowingReadAccessToURL(
      NSURL.fileURLWithPath(chatAIConfig.mainPath + '/response.html'),
      NSURL.fileURLWithPath(chatAIConfig.mainPath + '/')
    );
  }
}
/** @this {notificationController} */
notificationController.prototype.setResponseText = async function (funcResponse = "") {
  // MNUtil.copy(this.response)
  this.response = this.response.trim()
    .replace(/(\\\[\s?)|(\s?\\\])/g, '$$') // Replace display math mode delimiters
    .replace(/(\\\(\s?)|(\s?\\\))/g, '$') // Replace inline math mode opening delimiter
  // if (this.onResponse) {
  //   MNUtil.showHUD("On response")
  //   return
  // }
  try {
  let md2html = MNUtil.md2html(this.response)
  if (!this.onChat) {
    // copy(marked.parse(this.response))
    // this.webviewResponse.loadHTMLStringBaseURL(marked.parse(this.response))
    // copy(marked.parse(response))
    // let md2html = marked.parse(response)
    // let convertText = response
    // .replace(/(\\\[)|(\\\])/g, '$$') // Replace display math mode delimiters
    // .replace(/\\\(\s?/g, '$') // Replace inline math mode opening delimiter
    // .replace(/\\\)/g, '$');

    // MNUtil.copy(md2html)
    // md2html = MathJax.typeset([md2html])
    if (funcResponse) {
      md2html = `<pre><code class="hljs">${funcResponse.trim()}</code></pre>`+md2html
    }
    // let htmlText = chatAIUtils.html(md2html,this.scrollToBottom)

    // htmlText = htmlText.replace(/<code>/g, "<pre><code>").replace(/<\/code>/g, "</code></pre>")
    // MNUtil.copy(md2html)
    // this.webviewResponse.loadHTMLStringBaseURL(htmlText)
    // copy(response)
    this.onResponse = true
    // let timeBegin = Date.now()
    // MNUtil.copy(response)
    this.sizeHeight = await this.setWebviewContent(md2html, this.scrollToBottom)
    // if (this.scrollToBottom) {
    //   await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typesetPromise().then(() => {window.scrollTo(0,document.body.scrollHeight)});`)
    // }else{
    //   await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typeset();`)
    // }
    // copy(res)
    // this.sizeHeight = await this.getWebviewHeight()
    // MNUtil.copy("0:"+height+";1:"+this.sizeHeight)
    // MNUtil.copy("time:"+(Date.now()-timeBegin))
    // MNUtil.showHUD("js"+this.sizeHeight)
    // this.sizeHeight = parseInt(await this.runJavaScript(`document.body.scrollHeight`))+35
    this.onResponse = false
    // let scrollview = this.webviewResponse.scrollView.contentSize
  }else{
      
    // let convertText = response
    // .replace(/(\\\[)|(\\\])/g, '$$') // Replace display math mode delimiters
    // .replace(/\\\(\s?/g, '$') // Replace inline math mode opening delimiter
    // .replace(/\\\)/g, '$');
    // let md2html = marked.parse(response)

    // MNUtil.copyJSON(MathJax)
    // md2html = MathJax.typeset([md2html])
    if (funcResponse) {
      md2html = `<pre><code class="hljs">${funcResponse.trim()}</code></pre>`+md2html
    }
    // let htmlText = chatAIUtils.html(md2html,false,false)
    // htmlText = htmlText.replace(/<code>/g, "<pre><code>").replace(/<\/code>/g, "</code></pre>")
    // MNUtil.copy(md2html)
    // this["assistant"+this.round].loadHTMLStringBaseURL(htmlText)
    // await this.runJavaScript(`document.body.innerHTML = "${MNUtil.escapeString(htmlText)}"; MathJax.typeset();`,"assistant"+this.round)
    // await MNUtil.delay(0.1)
    // let sizeHeight = await this.getWebviewHeight("assistant"+this.round)
    let sizeHeight = await this.setWebviewContent(md2html, false, "assistant"+this.round)

    this["assistant"+this.round].sizeHeight = sizeHeight

    // this[this.targetTextview].text = this.response
  }
    } catch (error) {
      MNUtil.showHUD("Error in setResponseText: "+error)

    }
}

/**
 * addToolMessage是要给ai看的，codifyToolCall是要给用户看的
 * @param {{index:number,id:string,type:string,function:{name:string,arguments:string}}} func 
 * @returns 
 * @this {notificationController}
 */
notificationController.prototype.executeFunctionByAI = function (func) {
try {
  let note,title,comment
  let funcName = func.function.name
  let arguments = MNUtil.getValidJSON(func.function.arguments)
  let noteid = this.noteid ?? chatAIUtils.currentNoteId ?? (chatAIUtils.getFocusNote() ? chatAIUtils.getFocusNote().noteId : undefined)
  switch (funcName) {
    case "multi_tool_use.parallel":
      this.func = []
      let tool_uses = arguments.tool_uses
      let toolMessages = []
      tool_uses.map((tool_use,index)=>{
        switch (tool_use.recipient_name) {
          case "functions.setTitle":
            if (!noteid) {
              MNUtil.showHUD("Unavailable")
              break
              // this.addToolMessage("Execution failed! There is no card selected",func.id)
              // return "Error in setTitle(): There is no card selected\n"
            }
            let title = tool_use.parameters.title.trim()
            if (!title) {
              MNUtil.showHUD("Empty title")
              break
              // copyJSON(this.func)
              // this.addToolMessage("Execution failed! The title provided is empty!",func.id)
              // return "Error in setTitle(): The title provided is empty!\n"
            }
            this.func.push({type:"function",function:{name:"setTitle",arguments:JSON.stringify({title:title})},id:func.id,index:index})
            note = MNUtil.getNoteById(noteid)
            MNUtil.undoGrouping(()=>{
              note.noteTitle = MNUtil.mergeWhitespace(title.trim())
            })
            toolMessages.push("Title is set")
            // this.addToolMessage("Title is set",func.id)
            break;
          case "functions.addComment":
            if (!noteid) {
              MNUtil.showHUD("Unavailable")
              break
              // this.addToolMessage("Execution failed! There is no card selected",func.id)
              // return "Error in addComment(): There is no card selected\n"
            }
            let comment = tool_use.parameters.comment.trim()
            if (!comment) {
              MNUtil.showHUD("Empty comment")
              break
              // copyJSON(this.func)
              // this.addToolMessage("Execution failed! The comment provided is empty!",func.id)
              // return "Error in addComment(): The comment provided is empty!\n"
            }
            // this.addToolMessage("Comment is added",func.id)
            this.func.push({type:"function",function:{name:"addComment",arguments:JSON.stringify({comment:comment})},id:func.id,index:index})
            note = MNUtil.getNoteById(noteid)
            MNUtil.undoGrouping(()=>{
              try {
                note.appendMarkdownComment(MNUtil.mergeWhitespace(comment))
              } catch (error) {
                note.appendTextComment(MNUtil.mergeWhitespace(comment))
              }
            })
            toolMessages.push("Comment is added")
            // this.addToolMessage("Comment is added",func.id)
            break;
          default:
            break;
        }
      
      })
      // MNUtil.copyJSON(tool_uses)
      this.addToolMessage(toolMessages.join("\n"),func.id)
      break;
    case "setTitle":
      // MNUtil.copyJSON(this.func)
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in setTitle(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in setTitle(): Empty arguments!\n"
      }
      if (!arguments.title.trim()) {
        MNUtil.showHUD("Empty title")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The title provided is empty!",func.id)
        return "Error in setTitle(): Empty title!\n"
      }
      this.addToolMessage("Title is set",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.noteTitle = MNUtil.mergeWhitespace(arguments.title.trim())
      })
      break;
    case "addComment":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in addComment(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addComment(): Empty arguments!\n"
      }
      if (!arguments.comment.trim()) {
        MNUtil.showHUD("Empty comment")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The comment provided is empty!",func.id)
        return "Error in addComment(): Empty comment!\n"
      }
      this.addToolMessage("Comment is added",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        try {
          note.appendMarkdownComment(MNUtil.mergeWhitespace(arguments.comment.trim()))
        } catch (error) {
          note.appendTextComment(MNUtil.mergeWhitespace(arguments.comment.trim()))
        }
      })
      break;
    case "addTag":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in addTag(): There is no card selected\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addTag(): Empty arguments!\n"
      }
      if (!arguments.tag.trim()) {
        MNUtil.showHUD("Empty tag")
        // copyJSON(this.func)
        this.addToolMessage("Execution failed! The tag provided is empty!",func.id)
        return "Error in addTag(): Empty tag!\n"
      }
      this.addToolMessage("Tag is added",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.appendTextComment("#"+MNUtil.mergeWhitespace(arguments.tag.trim()))
      })
      // this.response = this.response+"set title"
      break;
    case "copyCardURL":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "Error in copyCardURL(): There is no card selected\n"
      }
      this.addToolMessage("Link is copied",func.id)
      // note = getNoteById(noteid)
      MNUtil.copy(MNNote.new(noteid).noteURL)
      break;
    case "copyMarkdownLink":
      if (!noteid) {
        MNUtil.showHUD("Unavailable")
        this.addToolMessage("Execution failed! There is no card selected",func.id)
        return "` Error in copyMarkdownLink(): There is no card selected `\n\n"
      }
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in copyMarkdownLink(): Empty arguments!\n"
      }
      this.addToolMessage("Markdown Link is copied",func.id)
      note = MNUtil.getNoteById(noteid)
      MNUtil.copy(`[${arguments.title.trim()}](${chatAIUtils.getUrlByNoteId(noteid)})`)
      // this.response = this.response+"set title"
      break;
    case "copyText":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in copyText(): Empty arguments!\n"
      }
      if (!arguments.text.trim()) {
        MNUtil.showHUD("Empty text")
        this.addToolMessage("Execution failed! The text provided is empty!",func.id)
        return "Error in copyText(): Empty text!\n"
      }
      this.addToolMessage("Pure text is copied",func.id)
      MNUtil.copy(arguments.text.trim())
      // this.response = this.response+"set title"
      break;
    case "close":
      this.addToolMessage("Conversation is ended",func.id)
      // this.response = this.response+"set title"
      break;
    case "clearExcerpt":
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.excerptText = ""
      }) 
      this.addToolMessage("excerpt is cleared", func.id)
      break;
    case "setExcerpt":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in setExcerpt(): Empty arguments!\n"
      }
      if (!arguments.excerpt.trim()) {
        MNUtil.showHUD("Empty excerpt")
        this.addToolMessage("Execution failed! The excerpt provided is empty!",func.id)
        return "Error in setExcerpt(): Empty excerpt!\n"
      }
      note = MNUtil.getNoteById(noteid)
      MNUtil.undoGrouping(()=>{
        note.excerptText = arguments.excerpt.trim()
      }) 
      this.addToolMessage("excerpt is set", func.id)
      break;
    case "addChildNote":
      if (!arguments) {
        MNUtil.showHUD("Empty arguments")
        this.addToolMessage("Execution failed! The arguments provided is empty!",func.id)
        return "Error in addChildNote(): Empty arguments!\n"
      }
      let title = arguments.title
      let config = {markdown:true}
      if (title) {
        config.title = title.trim()
      }
      let content = arguments.content
      if (content) {
        config.content = content.trim()
      }
      note = MNNote.new(noteid)
      // MNNote.createChildNote
      note.createChildNote({title:title,content:content,markdown:true})
      
      // chatAIUtils.createChildNote(noteid, title, content)
      this.addToolMessage("child note is added",func.id)
      break 
    default:
      break;
  }
  return this.codifyToolCall(funcName,arguments)
  // return undefined
} catch (error) {
  MNUtil.showHUD("Error in executeFunctionByAI: "+error)
  MNUtil.copyJSON(func)
  return undefined
}
}

notificationController.prototype.setButtonOpacity = function (opacity) {
  if (this.onChat) {
    this.chatToolbar.layer.opacity = opacity
  }else{
    this.toolbar.layer.opacity = opacity
    // this.bigbangButton.layer.opacity = opacity
    // this.commentButton.layer.opacity = opacity
    // this.copyButton.layer.opacity = opacity
    // this.titleButton.layer.opacity = opacity
    // this.locationButton.layer.opacity = opacity
    // this.promptButton.layer.opacity = opacity
    // this.chatButton.layer.opacity = opacity
    // this.reloadButton.layer.opacity = opacity
    // this.aiLinkButton.layer.opacity = opacity
  }
}
/**
 * 
 * @param {string} content 
 */
notificationController.prototype.addToolMessage = function (content,funcId) {
  this.tool.push({"role":"tool","content":content,"tool_call_id":funcId})
}
/** @this {notificationController} */
notificationController.prototype.getTokens = async function () {
  let url = "https://api.moonshot.cn/v1/tokenizers/estimate-token-count"
  let key = chatAIConfig.config.moonshotKey
  if (!key) {
    key = "sk-ahKTZazcks2K7LJH6z7rUG8AN3rf6waioZUnwxiUmoEC2Jfx"
  }
  let headers = {
      Authorization: "Bearer "+key,
      "Content-Type": "application/json"
  }
  let history = this.history.filter(message=>!message.tool_calls && message.role !== "tool")
  let body = {
    "model":"moonshot-v1-128k",
    "messages":history
  }
  let options = {
        method: "Post",
        timeout: 60,
        headers: headers,
        json:body
      }
    return new Promise((resolve, reject) => {
    // UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    const queue = NSOperationQueue.mainQueue()
    const request = chatAINetwork.initRequest(url, options)
    NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
      request,
      queue,
      (res, data, err) => {
        if (err.localizedDescription) {
          MNUtil.showHUD(err.localizedDescription)
          reject(err.localizedDescription)
        }
        // if (data.length() === 0) resolve({})
        const result = NSJSONSerialization.JSONObjectWithDataOptions(
          data,
          1<<0
        )
        if (NSJSONSerialization.isValidJSONObject(result)) {
          resolve(result)
          if (!result.error) {
            let token = result.data.total_tokens
            this.token.push(Number(token))
            if (this.onChat) {
              this.chatToken.setTitleForState("...",0)
            }else{
              this.promptButton.setTitleForState("...",0)
            }
            this.setToken(token)
          }else{
            // copyJSON(result.error)
          }
        }
        resolve(result)
      }
    )
  })
}
/** @this {notificationController} */
notificationController.prototype.setToken = function (token) {
    if (this.onChat) {
        this.chatToken.setTitleForState(""+token+" ("+chatAIUtils.sum(this.token)+")",0)
    }else{
      if (!this.func) {
        if (this.token.length ===1) {
          this.promptButton.setTitleForState(token,0)
        }else{
          this.promptButton.setTitleForState(chatAIUtils.sum(this.token),0)
        }
      }
    }
}
/** @this {notificationController} */
notificationController.prototype.getModelName = function (source) {
  let modelNames
  let model
  switch (source) {
    case "ChatGLM":
      modelNames = chatAIConfig.modelNames("ChatGLM")
      model = modelNames[chatAIConfig.config.chatglmModel]
      return model
    case "Claude":
      modelNames = chatAIConfig.modelNames("Claude")
      model = modelNames[chatAIConfig.config.claudeModel]
      return model
    case "Gemini":
      modelNames = chatAIConfig.modelNames("Gemini")
      model = modelNames[chatAIConfig.config.geminiModel]
      return model
    case "Custom":
      modelNames = chatAIConfig.config.customModel.split(",")
      model = modelNames[chatAIConfig.config.customModelIndex]
      return model
    case "KimiChat":
      modelNames = chatAIConfig.modelNames("KimiChat")
      model = modelNames[chatAIConfig.config.moonshotModel]
      return model
    case "ChatGPT":
      modelNames = chatAIConfig.modelNames("ChatGPT")
      if (chatAIConfig.config.customModel) {
        let customModels = chatAIConfig.config.customModel.split(",")
        modelNames = modelNames.concat(customModels)
      }
      model = modelNames[chatAIConfig.config.model]
      return model
    case "Built-in":
      let keyInfo = chatAIUtils.chatController.keys["key"+chatAIConfig.config.tunnel]
      return keyInfo.model
    default:
      return undefined
  }
}
/**
 * @type {UIView}
 */
notificationController.prototype.view
/**
 * @type {chatglmController}
 */
notificationController.prototype.addonController