/** @return {chatglmController} */
const getChatglmController = ()=>self
var chatglmController = JSB.defineClass('chatglmController : UIViewController', {
  viewDidLoad: function() {
    try {
    let self = getChatglmController()
    self.init()
    self.view.frame = {x:50,y:50,width:(MNUtil.version.type !== "iPhoneOS") ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.moveDate = Date.now()
    self.onNewExcerpt = chatAIConfig.config.onNewExcerpt
    self.notifyLoc = chatAIConfig.config.notifyLoc
    //通过id获取文件内容
    self.fileContent = {}

    if (!chatAIConfig.config.delay) {
      chatAIConfig.config.delay = 0
    }
    if (chatAIConfig.config.ignoreShortText == undefined) {
      chatAIConfig.config.ignoreShortText = false
    }
    self.responseView = UIView.new()
    self.responseView.backgroundColor = MNUtil.hexColorAlpha("#f3f3f3")
    self.responseView.layer.cornerRadius = 13
    self.responseView.hidden = true
    self.view.addSubview(self.responseView)

    self.textviewResponse = UITextView.new()
    self.textviewResponse.font = UIFont.systemFontOfSize(16);
    self.textviewResponse.layer.cornerRadius = 8
    self.textviewResponse.backgroundColor = MNUtil.hexColorAlpha("#ffffff",0.8)
    self.textviewResponse.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewResponse)
    self.textviewResponse.text = `Loading...`
    self.textviewResponse.bounces = true

    self.textviewAsk = UITextView.new()
    self.textviewAsk.font = UIFont.systemFontOfSize(16);
    self.textviewAsk.layer.cornerRadius = 8
    self.textviewAsk.backgroundColor = MNUtil.hexColorAlpha("#a9ea7a",0.8)
    self.textviewAsk.textColor = UIColor.blackColor()
    self.responseView.addSubview(self.textviewAsk)
    self.textviewAsk.text = `Input here`
    self.textviewAsk.bounces = true


    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false


    self.createButton("closeButton","closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("maxButton","maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("moveButton")


    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    // self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.saveButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    // self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    // self.settingController.view.hidden = false
    } catch (error) {
      MNUtil.showHUD("Error in viewDidLoad: "+error)
      // MNUtil.copy(error)

    }
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
  viewWillLayoutSubviews: function() {
  try {
    let self = getChatglmController()
    // let buttonHeight = 25
    // self.view.frame = self.currentFrame
    var viewFrame = self.view.bounds;
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.closeButton.frame = MNUtil.genFrame(width-18,0,18,18)
    self.maxButton.frame = MNUtil.genFrame(width-43,0,18,18)
    self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 15,};
    self.responseView.frame = {x:1,y:6,width:width-2,height:height-36}
    height = height-36
    self.textviewAsk.frame = {x:100,y:10,width:width-110,height:height*0.5-20}
    self.textviewResponse.frame = {x:10,y:height*0.5,width:width-110,height:height*0.5-10}
    self.settingViewLayout()
    self.refreshLayout()
  } catch (error) {
    MNUtil.showHUD("ChatAI: Error in viewWillLayoutSubviews: "+error)
  }

  },
  changeSearchOrder: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:chatAIConfig.config.searchOrder ==[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:chatAIConfig.config.searchOrder==[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:chatAIConfig.config.searchOrder==[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:chatAIConfig.config.searchOrder==[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:chatAIConfig.config.searchOrder==[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:chatAIConfig.config.searchOrder==[3,2,1]},
    ];
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250)
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,250,1)
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.searchOrder = order
    self.orderButton.setTitleForState(chatAIConfig.getOrderText(),0)
    chatAIConfig.save("MNChatglm_config")
  },
  changeSource: function(sender) {
    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'Custom',object:self,selector:'setSource:',param:'Custom',checked:chatAIConfig.config.source =='Custom'},
      {title:'Gemini',object:self,selector:'setSource:',param:'Gemini',checked:chatAIConfig.config.source =='Gemini'},
      {title:'Claude',object:self,selector:'setSource:',param:'Claude',checked:chatAIConfig.config.source =='Claude'},
      {title:'ChatGLM',object:self,selector:'setSource:',param:'ChatGLM',checked:chatAIConfig.config.source =='ChatGLM'},
      {title:'ChatGPT',object:self,selector:'setSource:',param:'ChatGPT',checked:chatAIConfig.config.source =='ChatGPT'},
      {title:'KimiChat',object:self,selector:'setSource:',param:'KimiChat',checked:chatAIConfig.config.source =='KimiChat'},
      {title:'Built-in',object:self,selector:'setSource:',param:'Built-in',checked:chatAIConfig.config.source =='Built-in'}
    ];
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,250,1)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setSource: function(param) {
  let self = getChatglmController()
  try {
    // let viewFrame = self.view.bounds
    // let width = viewFrame.width
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.source = param
    self.sourceButton.setTitleForState("Source: "+chatAIConfig.config.source,0)
    self.setModel(chatAIConfig.config.source)
    self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  changeModel: function(sender) {
    let self = getChatglmController()
  try {
    
    var commandTable
    let config = chatAIConfig.config
    let modelNames = chatAIConfig.modelNames(config.source)
    switch (config.source) {
      case "ChatGLM":
        commandTable = modelNames.map((model,index)=>{
          return {title:model,object:self,selector:'setModel:',param:index,checked:config.chatglmModel == index}
        })
        // commandTable = [
        //   {title:"GLM-3-Turbo",object:self,selector:'setModel:',param:0,checked:config.chatglmModel ==0},
        //   {title:"GLM-4",object:self,selector:'setModel:',param:1,checked:config.chatglmModel ==1},
        //   {title:"GLM-4v",object:self,selector:'setModel:',param:2,checked:config.chatglmModel ==2},
        // ];
        break;
      case "Claude":
        commandTable = modelNames.map((model,index)=>{
          return {title:model,object:self,selector:'setModel:',param:index,checked:config.claudeModel == index}
        })
        // commandTable = [
        //   {title:"claude-3-haiku-20240307",object:self,selector:'setModel:',param:0,checked:config.claudeModel ==0},
        //   {title:"claude-3-sonnet-20240229",object:self,selector:'setModel:',param:1,checked:config.claudeModel ==1},
        //   {title:"claude-3-opus-20240229",object:self,selector:'setModel:',param:2,checked:config.claudeModel ==2},
        // ];
        break;
      case "Gemini":
        // modelNames = chatAIConfig.modelNames("Gemini")
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:config.geminiModel == index}
        })
        // commandTable = [
        //   {title:"gemini-pro",object:self,selector:'setModel:',param:0,checked:config.geminiModel ==0},
        //   {title:"gemini-pro-vision",object:self,selector:'setModel:',param:1,checked:config.geminiModel ==1},
        //   {title:"gemini-1.5-pro-latest",object:self,selector:'setModel:',param:2,checked:config.geminiModel ==2},
        // ];
        break;
      case "ChatGPT":
        // modelNames = chatAIConfig.modelNames("ChatGPT")
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:config.model == index}
        })
        break
      case "KimiChat":
        commandTable = modelNames.map((model,index)=>{
          return { title:model,object:self,selector:'setModel:',param:index,checked:config.moonshotModel == index}
        })
        // commandTable = [
        //   {title:"moonshot-v1-8k",object:self,selector:'setModel:',param:0,checked:config.moonshotModel ==0},
        //   {title:"moonshot-v1-32k",object:self,selector:'setModel:',param:1,checked:config.moonshotModel ==1},
        //   {title:"moonshot-v1-128k",object:self,selector:'setModel:',param:2,checked:config.moonshotModel ==2}
        // ];
        break;
      case "Custom":
        // modelNames = config.customModel.split(",")
        // if (modelNames.length === 0) {
        //   showHUD("请至少添加一个模型")
        //   return
        // }
        commandTable = modelNames.map((model,index)=>{
          return {title:model.trim(),object:self,selector:'setModel:',param:index,checked:config.customModelIndex == index}
        })
        break
      default:
        break;
    }
    // self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,250)
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,250,4)

  } catch (error) {
    showHUD(error)
  }
  },
  setModel: function (modelIndex) {
    let self = getChatglmController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // chatAIConfig.config.model = params
    switch (chatAIConfig.config.source) {
      case "ChatGLM":
        chatAIConfig.config.chatglmModel = modelIndex
        break;
      case "Claude":
        chatAIConfig.config.claudeModel = modelIndex
        break;
      case "ChatGPT":
        chatAIConfig.config.model = modelIndex
        break;
      case "KimiChat":
        chatAIConfig.config.moonshotModel = modelIndex
        break;
      case "Custom":
        chatAIConfig.config.customModelIndex = modelIndex
        break;
      case "Gemini":
        chatAIConfig.config.geminiModel = modelIndex
        break;
      default:
        break;
    }
    chatAIConfig.defaultModel = chatAIConfig.getDefaultModel()
    MNUtil.showHUD("modelindex: "+chatAIConfig.defaultModel)

    self.setModel(chatAIConfig.config.source)
    // self.setModelButton(chatAIConfig.config.source)
    chatAIConfig.save("MNChatglm_config")
  },
  saveCustomModels: function (params) {
    chatAIConfig.config.customModel = self.customModelInput.text
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Save model")
  },
  changeFunc: function (button) {
    let self = getChatglmController()
    try {
      if (!chatAIUtils.checkSubscribe(false)) {
        return
      }
      let currentFunc 
      let selector
      if (self.contextButton.currentTitle === "Text") {
        // MNUtil.showHUD("dynamicFunc")
        currentFunc = chatAIConfig.getConfig("dynamicFunc")
        selector = 'setDynamicFunc:'
      }else{
        currentFunc = chatAIConfig.currentFunc
        selector = 'setFunc:'
      }
    var commandTable = [
          {title:"Set Title",object:self,selector:selector,param:0,checked:currentFunc.includes(0)},
          {title:"Add Comment",object:self,selector:selector,param:1,checked:currentFunc.includes(1)},
          {title:"Add Tag",object:self,selector:selector,param:6,checked:currentFunc.includes(6)},
          {title:"Add Child Note",object:self,selector:selector,param:7,checked:currentFunc.includes(7)},
          {title:"Copy MD Link",object:self,selector:selector,param:2,checked:currentFunc.includes(2)},
          {title:"Copy Card URL",object:self,selector:selector,param:3,checked:currentFunc.includes(3)},
          {title:"Copy Text",object:self,selector:selector,param:4,checked:currentFunc.includes(4)},
          {title:"Clear Excerpt",object:self,selector:selector,param:8,checked:currentFunc.includes(8)},
          {title:"Set Excerpt",object:self,selector:selector,param:9,checked:currentFunc.includes(9)},
          {title:"Close",object:self,selector:selector,param:5,checked:currentFunc.includes(5)},
          {title:"None",object:self,selector:selector,param:-1,checked:currentFunc.length === 0},
          {title:"All",object:self,selector:selector,param:100,checked:currentFunc.length === 9},
        ];
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
    
    // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      showHUD(error)
    }
  },
  setFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
    let currentFunc = chatAIConfig.currentFunc
    switch (param) {
      case -1:
        currentFunc = []
        break;
      case 100:
        currentFunc = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          currentFunc.push(param)
        }
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    // chatAIUtils.copyJSON(currentFunc)
    chatAIConfig.currentFunc = currentFunc
    chatAIConfig.prompts[chatAIConfig.currentPrompt].func = currentFunc
    chatAIConfig.save("MNChatglm_prompts")
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  setDynamicFunc(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe()) {
      return
    }
try {
    let currentFunc = chatAIConfig.config.dynamicFunc ? chatAIConfig.config.dynamicFunc : []
    switch (param) {
      case -1://None
        currentFunc = []
        break;
      case 100://All
        currentFunc = [0,1,2,3,4,5,6,7,8,9]//增加函数后要在这里加一条，不然显示不出来
        break
      default:
        if (currentFunc.includes(param)) {
          //已经选中了则去除选中状态
          currentFunc = currentFunc.filter(func=> func!==param)
        }else{
          //未选中则增加
          currentFunc.push(param)
        }
        //排序
        currentFunc.sort(function(a, b) {
          return a - b;
        });
        break;
    }
    chatAIConfig.config.dynamicFunc = currentFunc
    chatAIConfig.save("MNChatglm_config")
} catch (error) {
  MNUtil.showHUD(error)
}

  },
  changePromptModel:function (button) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    try {
    let selector = 'setPromptModel:'
    let modelName = chatAIConfig.currentModel
    // MNUtil.showHUD(self.contextButton.currentTitle)
    if (self.contextButton.currentTitle === "Text") {
      // MNUtil.showHUD("dynamicFunc")
      modelName = chatAIConfig.getConfig("dynamicModel")
      selector = 'setDynamicModel:'
    }
    let customModels = chatAIConfig.config.customModel ? chatAIConfig.config.customModel.split(",") : []
    let chatgptModels = chatAIConfig.modelNames("ChatGPT").concat(customModels).map(model=>{return "ChatGPT:"+model.trim()})
    let chatglmModels = chatAIConfig.getConfig("apikey") ? chatAIConfig.modelNames("ChatGLM").map(model=>{return "ChatGLM:"+model}) :[]
    let moonshotModels = chatAIConfig.getConfig("moonshotKey") ? chatAIConfig.modelNames("KimiChat").map(model=>{return "KimiChat:"+model}) : []
    let geminiModels = chatAIConfig.getConfig("geminiKey") ? chatAIConfig.modelNames("Gemini").map(model=>{return "Gemini:"+model}) : []
    let claudeModels = chatAIConfig.getConfig("claudeKey") ? chatAIConfig.modelNames("Claude").map(model=>{return "Claude:"+model}) : []
    let allModels = ["Default","Built-in"].concat(chatglmModels).concat(moonshotModels).concat(geminiModels).concat(claudeModels).concat(chatgptModels).concat(customModels.map(model=>{return "Custom:"+model.trim()}))
    var commandTable = [...new Set(allModels)].map(model=>{
      return {title:model,object:self,selector:selector,param:model,checked:modelName === model}
    })
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(button,commandTable,250,0)
    // self.view.popoverController = MNUtil.getPopoverAndPresent(button,commandTable,250)
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  setPromptModel: function (model) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (!chatAIUtils.checkSubscribe(false)) {
      return
    }
    // let config = model.split(":")
    let promptName = chatAIConfig.prompts[chatAIConfig.currentPrompt].title
    chatAIConfig.prompts[chatAIConfig.currentPrompt].model = model
    chatAIConfig.setCurrentPrompt(chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_prompts")
    MNUtil.showHUD("Set model for "+promptName+": ["+model+"]")
  },
  setDynamicModel: function (model) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    chatAIConfig.config.dynamicModel = model
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set model for Dynamic: ["+model+"]")
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  openSettingView:function () {
    let self = getChatglmController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }else{
    }
    self.settingViewLayout()
    
    try {
      self.setButtonText(chatAIConfig.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      self.settingView.hidden = false
    } catch (error) {
      showHUD(error)
      
    }

    // self.view.addSubview(self.tabView)
  },
  askWithPrompt: async function () {
    let self = getChatglmController()
    let config = {}
    config.title = self.titleInput.text ?? ""
    config.context = self.contextInput.text ?? ""
    config.system = self.systemInput.text ?? ""
    if (chatAIConfig.currentModel) {
      config.model = chatAIConfig.currentModel
    }
    if (chatAIConfig.currentFunc) {
      config.func = chatAIConfig.currentFunc
    }
    chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
    self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
    chatAIConfig.save("MNChatglm_prompts")
  try {
    chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
    chatAIUtils.notifyController.text = chatAIUtils.currentSelection
    self.ask()
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  resetConfig: function (button) {
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<300) {
      let self = getChatglmController()
      chatAIConfig.reset()
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.setTextview(chatAIConfig.currentPrompt)
      return
    }else{
      button.clickDate = clickDate
      showHUD("Double click to reset!")
    }
  },

  toggleWindowLocation: function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (chatAIConfig.config.notifyLoc) {
      case 1:
        chatAIConfig.config.notifyLoc = 0
        self.windowLocationButton.setTitleForState("Notification: Left",0)
        chatAIUtils.notifyController.locationButton.setTitleForState("Left",0)
        break;
      case 0:
        chatAIConfig.config.notifyLoc = 1
        self.windowLocationButton.setTitleForState("Notification: Right",0)
        chatAIUtils.notifyController.locationButton.setTitleForState("Right",0)
        break;
      default:
        break;
    }
    // chatAIUtils.notifyController.config = chatAIConfig.config
    chatAIConfig.save("MNChatglm_config")
  },
  closeButtonTapped: function() {
    if (chatAIUtils.addonBar) {
      self.hide(chatAIUtils.addonBar.frame)
    }else{
      self.hide()
    }
    self.searchedText = ""
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.hideAllButton()
      MNUtil.animate(()=>{
        self.view.frame = self.lastFrame
        self.currentFrame = self.lastFrame
      },0.3).then(()=>{
        self.showAllButton()
      })
      return
    }
    const frame = MNUtil.studyView.bounds
    self.lastFrame = self.view.frame
    self.customMode = "full"
    self.custom = true;
    self.hideAllButton()
    MNUtil.animate(()=>{
      self.view.frame = MNUtil.genFrame(40, 50, frame.width-80, frame.height-70)
      self.currentFrame = self.view.frame
    },0.3).then(()=>{
      self.showAllButton()
    })
  },
  onMoveGesture:function (gesture) {
    // let locationToMN = gesture.locationInView(MNUtil.studyView)
    //     MNUtil.showHUD("message")
    // if ((Date.now() - self.moveDate) > 100) {
    //   let translation = gesture.translationInView(MNUtil.studyView)
    //   let locationToBrowser = gesture.locationInView(self.view)
    //   let locationToButton = gesture.locationInView(gesture.view)
    //   let buttonFrame = self.moveButton.frame
    //   let newY = locationToButton.y-translation.y 
    //   let newX = locationToButton.x-translation.x
    //   if (gesture.state !== 3 && (newY<buttonFrame.height+5 && newY>-5 && newX<buttonFrame.width+5 && newX>-5 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
    //     gesture.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
    //     // MNUtil.showHUD(JSON.stringify(gesture.locationToBrowser))
    //     // self.locationToButton = {x:newX,y:newY}
    //   }else{
    //     // MNUtil.showHUD("message")
    //   }
    // }
    // self.moveDate = Date.now()
    // let location = {x:locationToMN.x - self.locationToButton.x-gesture.view.frame.x,y:locationToMN.y -self.locationToButton.y-gesture.view.frame.y}
    // let location = {x:locationToMN.x - gesture.locationToBrowser.x,y:locationToMN.y -gesture.locationToBrowser.y}
    let location = chatAIUtils.getNewLoc(gesture)
    let frame = self.view.frame
    self.view.frame = MNUtil.genFrame(location.x,location.y,frame.width,frame.height)
    self.currentFrame  = self.view.frame
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.5
    let height = locationToBrowser.y+baseframe.height*0.5
    if (width <= 375) {
      width = 375
    }
    if (height <= 485) {
      height = 485
    }
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  modelTabTapped: function (params) {
    self.switchView("modelView")
  },
  actionButtonTapped: function (params) {
    self.switchView("autoActionView")
  },
  advancedButtonTapped: function (params) {
    self.switchView("advanceView")
    if (chatAIConfig.config.source === "Built-in") {
      let usage  = chatAIConfig.usage
      self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }
  },
  syncConfigTapped: function (params) {
    self.switchView("syncView")
  },
  configButtonTapped: function (params) {
    self.switchView("configView")

  },
  configSystemTapped: function (params) {
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextInput.hidden = true
    self.systemInput.hidden = false
  },
  configContextTapped: function (params) {
    self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    self.contextInput.hidden = false
    self.systemInput.hidden = true
  },
  configSaveTapped: function (button) {
  // try {
  //     chatAIConfig.save("MNChatglm_prompts")
  //   // chatAIConfig.export(false)
  // } catch (error) {
  //   MNUtil.showHUD(error)
  // }
  // return
    try {
    let self = getChatglmController()
    if (self.contextButton.currentTitle === "Text") {
      chatAIConfig.dynamicPrompt.text = self.contextInput.text
      chatAIConfig.dynamicPrompt.note = self.systemInput.text
      chatAIConfig.save("MNChatglm_dynamicPrompt")
      MNUtil.showHUD("Save Dynamic prompt")
      return
    }
    // return
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<500) {
      if (MNUtil.studyMode === 3) {
        let focuseNote = MNNote.getFocusNote()
        chatAIUtils.currentNoteId = focuseNote.noteId
      }
      chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
      chatAIUtils.notifyController.text = chatAIUtils.currentSelection
      if (chatAIUtils.checkCouldAsk()) {
        self.ask()
      }
    }else{
      button.clickDate = Date.now()
      // chatAIConfig.export(false)
      // let noteId = chatAIConfig.config.syncNoteId
      // let focusNote = MNUtil.getNoteById(noteId)
      // MNUtil.copy(focusNote.noteId)
      // // let noteId0 = focusNote.noteId
      let oldConfig = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      let config = {}
      config.title = self.titleInput.text ?? ""
      config.context = self.contextInput.text ?? ""
      config.system = self.systemInput.text ?? ""
      if (chatAIConfig.currentModel) {
        config.model = chatAIConfig.currentModel
      }
      if (chatAIConfig.currentFunc) {
        config.func = chatAIConfig.currentFunc
      }
      if (JSON.stringify(oldConfig) === JSON.stringify(config)) {
        return
      }
      chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      MNUtil.delay(0.1).then(()=>{
        chatAIConfig.save("MNChatglm_prompts",false,false)
        MNUtil.showHUD("Save prompt: "+chatAIConfig.prompts[chatAIConfig.currentPrompt].title)
      })
    }
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  saveKnowledgeButtonTapped: function (params) {
    try {
      chatAIConfig.knowledge = self.knowledgeInput.text
      chatAIConfig.save("MNChatglm_knowledge")
      showHUD("Save knowledge")
    } catch (error) {
      showHUD(error);
    }
  },
  changeTunnel: function(sender) {
    var commandTable = [
      {title:'Tunnel 1️⃣',object:self,selector:'setTunnel:',param:0,checked:chatAIConfig.config.tunnel ==0},
      {title:'Tunnel 2️⃣',object:self,selector:'setTunnel:',param:1,checked:chatAIConfig.config.tunnel ==1},
      {title:'Tunnel 3️⃣',object:self,selector:'setTunnel:',param:2,checked:chatAIConfig.config.tunnel ==2},
      {title:'Tunnel 4️⃣',object:self,selector:'setTunnel:',param:3,checked:chatAIConfig.config.tunnel ==3},
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,150)
  },
  setTunnel: function name(param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let tunnels = ["Tunnel: 1️⃣","Tunnel: 2️⃣","Tunnel: 3️⃣","Tunnel: 4️⃣"]
    chatAIConfig.config.tunnel = param
    self.tunnelButton.setTitleForState(tunnels[param],0)
        chatAIConfig.save("MNChatglm_config")

  },
  refreshKey: async function (params) {
try {
    // let res = chatAIUtils.checkSubscribe()
    // MNUtil.showHUD(res)
    // return
    let self = getChatglmController()
    MNUtil.showHUD("Refreshing...")
    let keys = await chatAINetwork.fetchKeys()
    if (keys) {
      chatAIConfig.keys = keys 
      chatAIConfig.save('MNChatglm_builtInKeys')
      if (keys.message) {
        // copyJSON(keys)
        MNUtil.showHUD(keys.message)
      }else{
        MNUtil.showHUD("error")
      }
      self.refreshButton.setTitleForState(`Refresh (1️⃣: ${keys.key0.keys.length}, 2️⃣: ${keys.key1.keys.length}, 3️⃣: ${keys.key2.keys.length}, 4️⃣: ${keys.key3.keys.length})`,0)
    }else{
      MNUtil.showHUD("error")
    }
} catch (error) {
  MNUtil.showHUD(error)
}
  },
  refreshUsage: async function (button) {
    if (button.builtIn) {
      let usage  = chatAIConfig.usage
      self.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
    }else{
      let self = getChatglmController()
      MNUtil.showHUD("Fetching usage")
      let usage  = await chatAINetwork.getUsage()
      self.customUsage.setTitleForState(`Usage: ${(usage.usage/100.).toFixed(2)} / ${usage.total.toFixed(2)}`,0) 
    }
  },
  configAddTapped: function (params) {
    let self = getChatglmController()
    if (Object.keys(chatAIConfig.prompts).length >= 10 && !chatAIUtils.checkSubscribe()) {
      return
    }
    // MNUtil.showHUD("message"+Object.keys(chatAIConfig.prompts).length)
    self.titleInput.text = "New prompt"
    self.contextInput.text = "input your prompt"
    self.systemInput.text = ""
    let i = 0
    while (chatAIConfig.prompts["customEngine"+i]) {
      i = i+1
    }
    let prompts = chatAIConfig.prompts
    let config = {title:self.titleInput.text,context:self.contextInput.text}
    prompts["customEngine"+i] = config
    chatAIConfig.prompts = prompts
    chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.concat(("customEngine"+i))
    self.setButtonText(chatAIConfig.config.promptNames,"customEngine"+i)
    chatAIConfig.setCurrentPrompt("customEngine"+i)
    self.refreshLayout()
    chatAIConfig.save("MNChatglm_prompts")
  },
  addVariable: function (sender) {
    let vars = ['{{card}}','{{cardOCR}}','{{parentCard}}','{{parentCardOCR}}','{{context}}','{{textOCR}}','{{knowledge}}','{{noteDocInfo}}','{{currentDocInfo}}','{{noteDocName}}','{{currentDocName}}','{{selectionText}}','{{clipboardText}}']
    var commandTable = vars.map(variable=>{
      return {title:variable,object:self,selector:'insert:',param:variable}
    })
    self.view.popoverController = chatAIUtils.getPopoverAndPresent(sender,commandTable,200,4)
    // let self = getChatglmController()
    // let range = self.contextInput.selectedRange
    // let pre = self.contextInput.text.slice(0,range.location)
    // let post = self.contextInput.text.slice(range.location)
    // self.contextInput.text = pre+"{{context}}"+post
    // copyJSON(range)
  },
  insert: function (variable) {
    let self = getChatglmController()
    if (!chatAIUtils.checkSubscribe(true)) {
      return
    }
    if (!self.contextInput.hidden) {
      let range = self.contextInput.selectedRange
      let pre = self.contextInput.text.slice(0,range.location)
      let post = self.contextInput.text.slice(range.location+range.length)
      self.contextInput.text = pre+variable+post
    }
    if (!self.systemInput.hidden) {
      let range = self.systemInput.selectedRange
      let pre = self.systemInput.text.slice(0,range.location)
      let post = self.systemInput.text.slice(range.location+range.length)
      self.systemInput.text = pre+variable+post
    }
  },
  configDeleteTapped: function (button) {
    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<300) {
      // showHUD("length:"+chatAIConfig.prompts.length)
      if (Object.keys(chatAIConfig.prompts).length === 1) {
        MNUtil.showHUD("You can not clear all prompts!")
        return
      }
      delete chatAIConfig.prompts[chatAIConfig.currentPrompt]
      chatAIConfig.config.promptNames = chatAIConfig.config.promptNames.filter(item=>item !== chatAIConfig.config.currentPrompt)
      chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      self.refreshLayout()
      chatAIConfig.save("MNChatglm_config")
      chatAIConfig.save("MNChatglm_prompts")
      return
    }else{
      button.clickDate = clickDate
      MNUtil.showHUD("Double click to delete prompt!")
    }

  },
  pasteApiKey:function (params) {
    let apikey = UIPasteboard.generalPasteboard().string.trim()
    self.apiKeyInput.text = apikey
    chatAIConfig.saveApiKey(apikey)
  },
  importFromSubscription:function (params) {
    try {
    if (chatAIUtils.checkSubscribe(false)) {
      let apikey = subscriptionConfig.config.apikey
      if (!apikey.trim()) {
        MNUtil.showHUD("Empty key!")
        return
      }
      self.apiKeyInput.text = apikey
      self.URLInput.text = "https://api.feliks.top"
      // MNUtil.showHUD("Import success!")
      chatAIConfig.saveApiKey(apikey,"https://api.feliks.top")
      // chatAIConfig.save('MNChatglm_config')
    }

    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  saveApiKey:function (params) {
    chatAIConfig.saveApiKey(self.apiKeyInput.text)
  },
  pasteURL:function (params) {
    let URL = chatAIUtils.clipboardText().trim()
    self.URLInput.text = URL
    if (chatAIConfig.config.source === "Custom") {
      chatAIConfig.config.customUrl = URL
    }else{
      chatAIConfig.config.url = URL
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
  },
  saveURL:function (params) {
    try {
      
    if (chatAIConfig.config.source === "Custom") {
      chatAIConfig.config.customUrl = self.URLInput.text.trim()
    }else{
      chatAIConfig.config.url = self.URLInput.text.trim()
    }
    MNUtil.showHUD("Save url")
    chatAIConfig.save('MNChatglm_config')
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleSelected: async function (button) {
  try {
    

    let self = getChatglmController()
    button.isSelected = true//!button.isSelected
    self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)

    let clickDate = Date.now()
    if (button.clickDate && clickDate-button.clickDate<300) { 
      let currentFunc = chatAIConfig.currentFunc
      let config = {
        title:self.titleInput.text,
        context:self.contextInput.text,
        system:self.systemInput.text,
        func:currentFunc
      }
      if (chatAIConfig.currentModel) {
        config.model = chatAIConfig.currentModel
      }
      chatAIConfig.prompts[chatAIConfig.currentPrompt] = config
      self.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      chatAIUtils.notifyController.noteid = chatAIUtils.currentNoteId
      chatAIUtils.notifyController.text = chatAIUtils.currentSelection
      chatAIUtils.notifyController.currentPrompt = chatAIConfig.currentPrompt
      MNUtil.delay(0.1).then(()=>{
        chatAIConfig.save("MNChatglm_prompts",false,false)
      })
      if (chatAIUtils.currentSelection === "") {
        MNUtil.showHUD("no text/card selected")
        return
      }
      if (chatAIUtils.checkCouldAsk()) {
        self.ask(chatAIUtils.currentSelection)
      }
      return
    }else{
      button.clickDate = clickDate
    }
    let title = button.id
    chatAIConfig.setCurrentPrompt(title)
    self.words.forEach((entryName,index)=>{
      if (entryName !== title) {
        self["nameButton"+index].isSelected = false
        self["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
      }
    })
    // MNUtil.copyJSON(self.hiddens)
    button.backgroundColor = chatAIUtils.switchColor(button.isSelected)
    if (button.isSelected) {
      self.setTextview(title)
    }
    self.SystemButton.setTitleForState("System",0)
    self.contextButton.setTitleForState("User",0)
    chatAIConfig.save('MNChatglm_config')
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoAction:function () {
  try {
    chatAIConfig.config.autoAction = !chatAIConfig.config.autoAction
    chatAIConfig.save('MNChatglm_config')
    self.refreshView("autoActionView")
    return
    // self.autoActionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.autoAction)
    // let title = chatAIConfig.config.autoAction ? "Auto Action: ✅" : "Auto Action: ❌"
    // self.autoActionButton.setTitleForState(title)
    // self.onSelectionButton.hidden = !chatAIConfig.config.autoAction
    // self.onNewExcerptButton.hidden = !chatAIConfig.config.autoAction
    // self.newExcerptTagDetection.hidden = !chatAIConfig.config.autoAction
    // self.onNoteButton.hidden = !chatAIConfig.config.autoAction
    // self.ignoreButton.hidden = !chatAIConfig.config.autoAction
    // self.delayButton.hidden = !chatAIConfig.config.autoAction

    // for (let index = 0; index < 32; index++) {
    //   self["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
    // }
    // MNUtil.refreshAddonCommands()
      } catch (error) {
    chatAIUtils.show(error)
  }
  },
  toggleOnSelection:function () {
    chatAIConfig.config.onSelection = !chatAIConfig.config.onSelection
    chatAIConfig.save('MNChatglm_config')
    self.onSelectionButton.backgroundColor = chatAIUtils.switchColor(chatAIConfig.config.onSelection)
    if (chatAIConfig.config.onSelection) {
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",.8)
      self.onSelectionButton.setTitleForState("On Selection: ✅")
    }else{
      // self.onSelectionButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onSelectionButton.setTitleForState("On Selection: ❌")
    }
  },
  toggleOnNote:function () {
    chatAIConfig.config.onNote = !chatAIConfig.config.onNote
    chatAIConfig.save("MNChatglm_config")

    if (chatAIConfig.config.onNote) {
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNoteButton.setTitleForState("On Note: ✅")
    }else{
      self.onNoteButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNoteButton.setTitleForState("On Note: ❌")
    }
  },
  toggleOnNewExcerpt:function () {
    chatAIConfig.config.onNewExcerpt = !chatAIConfig.config.onNewExcerpt
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.onNewExcerpt) {
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ✅")
    }else{
      self.onNewExcerptButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.onNewExcerptButton.setTitleForState("On New Excerpt: ❌")
    }
  },
  toggleNewExcerptTagDetection:function () {
    if (!chatAIConfig.getConfig("newExcerptTagDetection") && !chatAIUtils.checkSubscribe()) {
      return
    }
    chatAIConfig.config.newExcerptTagDetection = !chatAIConfig.config.newExcerptTagDetection
    chatAIConfig.save('MNChatglm_config')
    if (chatAIConfig.config.newExcerptTagDetection) {
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ✅")
    }else{
      self.newExcerptTagDetection.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
      self.newExcerptTagDetection.setTitleForState("Tag detection: ❌")
    }
  },
  changeDelay: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'2.0s',object:self,selector:'changeDelayTo:',param:2.0},
      {title:'1.5s',object:self,selector:'changeDelayTo:',param:1.5},
      {title:'1.0s',object:self,selector:'changeDelayTo:',param:1.0},
      {title:'0.5s',object:self,selector:'changeDelayTo:',param:0.5}
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender,commandTable,100)
  },
  changeDelayTo: function(delay) {
    chatAIConfig.config.delay = delay
    self.delayButton.setTitleForState("Delay: "+delay+"s")
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Set delay to "+delay+"s")
  },
  toggleColorConfig: function (button) {
    if (chatAIConfig.config.colorConfig[button.index]) {
      chatAIConfig.config.colorConfig[button.index] = 0
      button.setTitleForState("✖️",0)
    }else{
      chatAIConfig.config.colorConfig[button.index] = 1
      button.setTitleForState("✓",0)
    }
    chatAIConfig.save("MNChatglm_config")

  },
  toggleDynamic: function () {
    let self = getChatglmController()
    try {
    if (self.contextButton.currentTitle === "User") {
      self.contextButton.setTitleForState("Text",0)
      self.SystemButton.setTitleForState("Note",0)
      self.titleInput.text = "Dynamic"
      self.titleInput.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      // copyJSON(chatAIConfig.dynamicPrompt)
      self.systemInput.text = chatAIConfig.dynamicPrompt.note
      self.contextInput.text = chatAIConfig.dynamicPrompt.text
    }else{
      if (chatAIConfig.config.dynamic) {
        chatAIConfig.config.dynamic = false
        self.dynamicButton.setTitleForState("Dynamic: ❌",0)
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
      }else{
        self.dynamicButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
        self.dynamicButton.setTitleForState("Dynamic: ✅",0)
        chatAIConfig.config.dynamic = true
      }
      chatAIConfig.save('MNChatglm_config')
    }
    // self.setButtonText(chatAIConfig.config.promptNames)
    // if (self.systemInput.hidden) {
    //   self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
    //   self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
    // }else{
    //   self.SystemButton.backgroundColor = MNUtil.hexColorAlpha("#fd3700",0.8)
    //   self.contextButton.backgroundColor = MNUtil.hexColorAlpha("#ff9375",0.8)
    // }
    // self.SystemButton.hidden = false
    } catch (error) {
      MNUtil.showHUD(error)
    }
  },
  toggleIgnoreShortText:function (button) {
    chatAIConfig.config.ignoreShortText = !chatAIConfig.config.ignoreShortText
    button.setTitleForState("Ignore short text: "+(chatAIConfig.config.ignoreShortText?"✅":"🚫"))
    if (chatAIConfig.config.ignoreShortText) {
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
    }else{
      self.ignoreButton.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    }
        chatAIConfig.save("MNChatglm_config")

  },
  exportConfig:async function (params) {
    let success = await chatAIConfig.export()
    if (success) {
      self.configNoteIdInput.text = chatAIConfig.config.syncNoteId
      chatAIConfig.save("MNChatglm_config")
      MNUtil.showHUD("Export Success!")
      let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(self.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
    }

  },
  importConfig:async function (params) {
    let success = await chatAIConfig.import()
    if (success) {
      MNUtil.showHUD("Import Success!")
    }
  },
  syncConfig: function (params) {
    let success = chatAIConfig.sync()
    // if (success) {
    //   MNUtil.showHUD("Sync Success!")
    // }
  },
  toggleAutoExport: function (params) {
  try {
    chatAIConfig.config.autoExport = !chatAIConfig.getConfig("autoExport")
    MNButton.setTitle(self.autoExportButton, "Auto Export: "+(chatAIConfig.getConfig("autoExport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoImport: function (params) {
    chatAIConfig.config.autoImport = !chatAIConfig.getConfig("autoImport")
    MNButton.setTitle(self.autoImportButton, "Auto Import: "+(chatAIConfig.getConfig("autoImport")?"✅":"❌"))
    chatAIConfig.save("MNChatglm_config")
  },
  pasteConfigNoteId:function (params) {
    let noteId = MNUtil.clipboardText
    let note = MNUtil.getNoteById(noteId)
    if (note) {
      self.configNoteIdInput.text = noteId
      chatAIConfig.config.syncNoteId = noteId
      chatAIConfig.save("MNChatglm_config")
      MNUtil.showHUD("Save Config NoteId")
    }else{
      MNUtil.showHUD("Note not exist!")
    }
  },
  clearConfigNoteId:function (params) {
    self.configNoteIdInput.text = ""
    chatAIConfig.config.syncNoteId = ""
    chatAIConfig.save("MNChatglm_config")
    MNUtil.showHUD("Clear Config NoteId")
  },
  focusConfigNoteId:function (params) {
  try {
    let noteId = chatAIConfig.config.syncNoteId
    let note = MNNote.new(noteId)
    if (note) {
      // MNUtil.focusNoteInMindMapById(noteId)
      note.focusInFloatMindMap()
      // MNUtil.focusNoteInFloatMindMapById(noteId)
      // MNUtil.testFunc()
    }else{
      // MNUtil.showHUD("456")

      MNUtil.showHUD("Note not exist!")
    }
  } catch (error) {
    MNUtil.showHUD("Error in focusConfigNoteId: "+error)
  }
  }
});
chatglmController.prototype.init = function () {
  // /**
  //  * @type {chatglmController}
  //  */
  // let ctr = this
  this.reloadImage = MNUtil.getImage(chatAIConfig.mainPath + `/reload.png`)
  this.stopImage = MNUtil.getImage(chatAIConfig.mainPath + `/stop.png`)
  this.settingImage = MNUtil.getImage(chatAIConfig.mainPath + `/setting.png`)
  this.searchedText = '';
  this.view.layer.shadowOffset = {width: 0, height: 0};
  this.view.layer.shadowRadius = 15;
  this.view.layer.shadowOpacity = 0.5;
  this.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
  this.view.layer.cornerRadius = 11
  this.view.layer.opacity = 1.0
  this.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
  this.view.layer.borderWidth = 0
  this.highlightColor = UIColor.blendedColor( MNUtil.hexColorAlpha("#2c4d81",0.8),
    chatAIUtils.app.defaultTextColor,
    0.8
  );
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestion = async function(promptKey = chatAIConfig.currentPrompt) {
try {
  //因为dynamicController可能还没有被创建，所以要加个判断
  let OCRMode = chatAIUtils.OCREnhancedMode
  let context = chatAIConfig.prompts[promptKey].context
  let system = chatAIConfig.prompts[promptKey].system
  let contextMessage
  let systemMessage
  let question
  if (chatAIUtils.currentNoteId) {
    contextMessage = await this.getNoteVarInfo(chatAIUtils.currentNoteId,context,OCRMode)
    if (system) {
      systemMessage = await this.getNoteVarInfo(chatAIUtils.currentNoteId,system,OCRMode)
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
      return question
    }
    question = [{role: "user", content: contextMessage}]
    return question
  }else{
    contextMessage = await this.getTextVarInfo(context,OCRMode)
    if (system) {
      systemMessage = await this.getTextVarInfo(system,OCRMode)
      question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
      return question
    }
    question = [{role: "user", content: contextMessage}]
    return question
  }
} catch (error) {
  showHUD("Error in getQuestion: "+error)
}
};

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnNote = async function(noteid,prompt = chatAIConfig.currentPrompt) {
  try {
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system
  let contextMessage
  let systemMessage
  let question
  let OCRMode = chatAIUtils.OCREnhancedMode
  contextMessage = await this.getNoteVarInfo(noteid,context,OCRMode)
  if (system) {
    systemMessage = await this.getNoteVarInfo(noteid,system,OCRMode)
    question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    return question
  }
  question = [{role: "user", content: contextMessage}]
  // copyJSON(question)
  return question
    } catch (error) {
    showHUD(error)
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getNoteVarInfo = async function(noteid,text,OCR_Enabled=false) {
  let config = {}
  let hasContext = text.includes("{{context}}")
  let hasOCR = text.includes("{{textOCR}}")
  let hasCard = text.includes("{{card}}")
  let hasCardOCR = text.includes("{{cardOCR}}")
  let hasParentCard = text.includes("{{parentCard}}")
  let hasParentCardOCR = text.includes("{{parentCardOCR}}")
  let hasKnowledge = text.includes("{{knowledge}}")
  let note = MNUtil.getNoteById(noteid)
  let contextVar = ""
  if (OCR_Enabled) {
    if (hasContext || hasOCR) {
      contextVar = await chatAIUtils.getTextForSearch(note,true)
      if (hasContext) { config.context = contextVar }
      if (hasOCR) { config.textOCR = contextVar }
    }
    if (hasCard || hasCardOCR) {
      let cardStructure = await this.genCardStructure(chatAIUtils.currentNoteId,true)
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      if (hasCard) {config.card = cardStructureString}
      if (hasCardOCR) {config.cardOCR = cardStructureString}
    }
    if (hasParentCard || hasParentCardOCR) {
      let parentNoteId = MNNote.new(chatAIUtils.currentNoteId).parentNote.noteId
      let cardStructure = await this.genCardStructure(parentNoteId,true)
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      if (hasParentCard) {
        config.parentCard = cardStructureString
      }else{
        config.parentCardOCR = cardStructureString
      }
    }
  }else{
    if (hasContext) {
      contextVar = await chatAIUtils.getTextForSearch(note)
      if (!contextVar) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      config.context = contextVar
    }
    if (hasCard) {
      let cardStructure = await this.genCardStructure(chatAIUtils.currentNoteId)
      // copyJSON(cardStructure)
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.card = cardStructureString
    }
    if (hasCardOCR) {
      let cardStructure = await this.genCardStructure(chatAIUtils.currentNoteId,true)
      // copyJSON(cardStructure)
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.cardOCR = cardStructureString
    }
    if (hasParentCard) {
      let parentNoteId = MNNote.new(chatAIUtils.currentNoteId).parentNote.noteId
      let cardStructure = await this.genCardStructure(parentNoteId)
      // copyJSON(cardStructure)
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.parentCard = cardStructureString
    }
    if (hasParentCardOCR) {
      let parentNoteId = MNNote.new(chatAIUtils.currentNoteId).parentNote.noteId
      let cardStructure = await this.genCardStructure(parentNoteId)
      // copyJSON(cardStructure)
      if (!Object.keys(cardStructure).length) {
        MNUtil.showHUD("No text in note/card!")
        return undefined
      }
      let cardStructureString = JSON.stringify(cardStructure,null,2)
      config.parentCardOCR = cardStructureString
    }
    if (hasOCR) {
      contextVar = await chatAIUtils.getTextForSearch(note,true)
      config.textOCR = contextVar
    }
  }
  if (text.includes("{{currentDocInfo}}")) {
    let currentFile = chatAIUtils.getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    config.currentDocInfo = await this.getFileContent(currentFile)
  }
  if (text.includes("{{noteDocInfo}}")) {
    let currentFile = chatAIUtils.getNoteFile(noteid)
    if (!currentFile) {
      currentFile = chatAIUtils.getCurrentFile()
    }
    if (!currentFile) {
      return undefined
    }
    config.noteDocInfo = await this.getFileContent(currentFile)
    // copy(fileContent)
  }
  if (hasKnowledge) {
    config.knowledge = chatAIConfig.knowledge
  }
  if (text.includes("{{clipboardText}}")) {
    config.clipboardText = MNUtil.clipboardText
  }
  if (text.includes("{{selectionText}}")) {
    config.selectionText = MNUtil.selectionText
  }
  if (text.includes("{{currentDocName}}")) {
    config.currentDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  if (text.includes("{{noteDocName}}")) {
    config.noteDocName = chatAIUtils.getNoteFileName(noteid)
  }
  let replacedText = chatAIUtils.replacVar(text, config)
  // MNUtil.copyJSON(replacedText)
  return replacedText
}


/**
 * @this {chatglmController}
 */
chatglmController.prototype.getTextVarInfo = async function(text,OCR_Enabled=false) {
  try {
  let config = {}
  let image = undefined
  let fileContent = undefined
  let hasOCR = text.includes("{{textOCR}}")
  let hasContext = text.includes("{{context}}")
  let hasCard = text.includes("{{card}}")
  let hasCardOCR = text.includes("{{cardOCR}}")
  let hasParentCard = text.includes("{{parentCard}}")
  let hasParentCardOCR = text.includes("{{parentCardOCR}}")
  let hasCurrentDocInfo = text.includes("{{currentDocInfo}}")
  let hasNoteDocInfo = text.includes("{{noteDocInfo}}")
  let selectedText = MNUtil.selectionText
  if (hasOCR || !selectedText || (OCR_Enabled && hasContext)) {
    // image = chatAIUtils.currentDocController().imageFromSelection()
    image = MNUtil.currentDocController.imageFromSelection()
  }
  if (image) {
    selectedText = await chatAINetwork.getTextOCR(image)
    if (hasOCR) {
      config.textOCR = selectedText
    }
  }
  if (hasContext) {
    config.context = selectedText
  }

  if (hasCard) {
    config.card = selectedText
  }
  if (hasCardOCR) {
    config.cardOCR = selectedText
  }
  if (hasParentCard) {
    config.parentCard = selectedText
  }
  if (hasParentCardOCR) {
    config.parentCardOCR = selectedText
  }

  if (hasCurrentDocInfo || hasNoteDocInfo) {
    let currentFile = chatAIUtils.getCurrentFile()
    if (!currentFile) {
      return undefined
    }
    fileContent = await this.getFileContent(currentFile)
    // copy(fileContent)
    if (hasCurrentDocInfo) {
      config.currentDocInfo = fileContent
    }
    if (hasNoteDocInfo) {
      config.noteDocInfo = fileContent
    }
  }
  if (text.includes("{{clipboardText}}")) {
    config.clipboardText = MNUtil.clipboardText
  }
  if (text.includes("{{selectionText}}")) {
    config.selectionText = MNUtil.selectionText
  }
  if (text.includes("{{currentDocName}}")) {
    config.currentDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  if (text.includes("{{noteDocName}}")) {
    config.noteDocName = MNUtil.getFileName(MNUtil.currentDocController.document.pathFile)
  }
  // copyJSON(config)
  return chatAIUtils.replacVar(text, config)
    } catch (error) {
    MNUtil.showHUD(error)
  }

}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.getQuestionOnText = async function(text,prompt = chatAIConfig.currentPrompt) {

  try {
  let context = chatAIConfig.prompts[prompt].context
  let system = chatAIConfig.prompts[prompt].system
  let OCRMode = chatAIUtils.OCREnhancedMode
  let contextMessage = await this.getTextVarInfo(context,OCRMode)
  if (system) {
    let systemMessage = await this.getTextVarInfo(system,OCRMode)
    // copy(systemMessage)
    let question = [{role:"system",content:systemMessage},{role: "user", content: contextMessage}]
    return question
  }
  let question = [{role: "user", content: contextMessage}]
  return question
    } catch (error) {
    MNUtil.showHUD(error)
  }

}
chatglmController.prototype.changeButtonOpacity = function(opacity) {
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
chatglmController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}


chatglmController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.settingViewLayout = function (){
    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.settingView.frame = MNUtil.genFrame(0, 20, width, height-20)
    this.configView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.modelView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.autoActionView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.advanceView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.syncView.frame = MNUtil.genFrame(0,40,width-2,height-80)

    // advanceView
    this.orderButton.frame = MNUtil.genFrame(10,15,width-20,35)

    this.sourceButton.frame = MNUtil.genFrame(10,15,width-20,35)
    this.apiKeyInput.frame = MNUtil.genFrame(10,55,width-20,75)
    this.pasteApiKeyButton.frame = MNUtil.genFrame(width-100,95,85,30)
    this.saveApiKeyButton.frame = MNUtil.genFrame(width-165,95,60,30)
    this.URLInput.frame = MNUtil.genFrame(10,135,width-20,40)
    this.pasteURLButton.frame = MNUtil.genFrame(width-100,140,85,30)
    this.saveURLButton.frame = MNUtil.genFrame(width-165,140,60,30)
    this.setModel(chatAIConfig.config.source)
    this.customUsage.frame = MNUtil.genFrame(200,185,width-210,40)
    this.tunnelButton.frame = MNUtil.genFrame(10,80,(width-25)*0.5-30,40)
    this.usageButton.frame = MNUtil.genFrame(15+(width-25)*0.5-30,80,(width-25)*0.5+30,40)
    this.refreshButton.frame = MNUtil.genFrame(10,125,width-20,40)

    
    this.autoActionButton.frame = MNUtil.genFrame(10,15,width-20,35)
    this.onSelectionButton.frame = MNUtil.genFrame(10,60,(width-25)*0.5,35)
    this.delayButton.frame = MNUtil.genFrame((width-25)*0.5+15,60,(width-25)*0.5,35)
    this.onNewExcerptButton.frame = MNUtil.genFrame(10,105,(width-25)*0.5,35)
    this.newExcerptTagDetection.frame = MNUtil.genFrame((width-25)*0.5+15,105,(width-25)*0.5,35)
    this.onNoteButton.frame = MNUtil.genFrame(10,240,(width-20),35)
    this.ignoreButton.frame = MNUtil.genFrame(10,370,(width-20),35)


    this.contextInput.frame = {x:10,y:215,width:width-100,height:height-285}
    this.systemInput.frame = {x:10,y:215,width:width-100,height:height-285}
    this.knowledgeInput.frame = {x:10,y:190,width:width-20,height:height-300}
    this.saveKnowledgeButton.frame = {x:10,y:height-105,width:(width-25)*0.5,height:35}
    this.windowLocationButton.frame = MNUtil.genFrame(15+(width-25)*0.5,height-105,(width-25)*0.5,35)
    this.titleInput.frame = {x:10,y:175,width:width-100,height:35}
    this.funcButton.frame = {x:width-85,y:175,width:75,height:35}
    this.promptModel.frame = {x:width-85,y:215,width:75,height:35}
    this.saveButton.frame = {x:width-85,y:height-105,width:75,height:35}
    this.scrollview.frame = {x:10,y:15,width:width-20,height:150}
    this.scrollview.contentSize = {width:width-20,height:height};
    this.newEntryButton.frame = {x:width-45,y:130,width:30,height:30}
    this.addVarButton.frame = {x:width-125,y:height-105,width:30,height:30}
    this.configReset.frame = {x:width-150,y:130,width:60,height:30}
    this.deleteButton.frame = {x:width-85,y:130,width:35,height:30}
    this.SystemButton.frame = {x:width-85,y:295,width:75,height:35}
    this.contextButton.frame = {x:width-85,y:255,width:75,height:35}

    this.syncTimeButton.frame = MNUtil.genFrame(10,80,width-20,35)
    this.exportConfigButton.frame = MNUtil.genFrame(10,120,width-20,35)
    this.importConfigButton.frame = MNUtil.genFrame(10,160,width-20,35)
    this.autoExportButton.frame = MNUtil.genFrame(10,200,(width-25)*0.5,35)
    this.autoImportButton.frame = MNUtil.genFrame(15+(width-25)*0.5,200,(width-25)*0.5,35)
    this.configNoteIdInput.frame = MNUtil.genFrame(10,10,width-20,65)
    this.pasteConfigNoteButton.frame = MNUtil.genFrame(width-75,40,60,30)
    this.clearConfigNoteButton.frame = MNUtil.genFrame(width-140,40,60,30)
    this.focusConfigNoteButton.frame = MNUtil.genFrame(width-205,40,60,30)

    let initX = 10
    let initY = 145

    for (let index = 0; index < 32; index++) {
      if (index == 8) {
        initX = 10
        initY = 190
      }
      if (index == 16) {
        initX = 10
        initY = 280
      }
      if (index == 24) {
        initX = 10
        initY = 325
      }
      this["ColorButton"+index].frame = MNUtil.genFrame(initX,initY,40,40)
      // this["ColorButton"+index].setTitleForState(chatAIConfig.config.colorConfig[index]?"✓":"✖️",0)
      this["ColorButton"+index].setTitleForState(chatAIConfig.getConfig("colorConfig")[index]?"✓":"✖️",0)
      initX = initX+45
    }


    let settingFrame = this.settingView.bounds
    settingFrame.x = 5
    settingFrame.y = 5
    settingFrame.height = 40
    settingFrame.width = settingFrame.width-10
    this.tabView.frame = settingFrame
    settingFrame.width = 75
    settingFrame.y = 10
    settingFrame.x = 10
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 90
    settingFrame.width = 65
    this.modelTab.frame = settingFrame
    settingFrame.x = 160
    settingFrame.width = 65
    this.actionButton.frame = settingFrame
    settingFrame.x = 230
    settingFrame.width = 65
    this.syncConfig.frame = settingFrame
    settingFrame.x = 300
    settingFrame.width = 65
    this.advancedButton.frame = settingFrame
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.createSettingView = function (){
try {
  
  //创建各分页
  let targetView = "settingView"
  let boldFont = UIFont.boldSystemFontOfSize(16)
  this.creatView(targetView,"view","#ffffff",1.0)
  this.settingView.hidden = true
  this.creatView("tabView",targetView)
  this.creatView("configView",targetView,"#9bb2d6",0.0)

  this.creatView("modelView",targetView,"#9bb2d6",0.0)
  this.modelView.hidden = true

  this.creatView("autoActionView",targetView,"#9bb2d6",0.0)
  this.autoActionView.hidden = true

  this.creatView("advanceView",targetView,"#9bb2d6",0.0)
  this.advanceView.hidden = true

  this.creatView("syncView",targetView,"#9bb2d6",0.0)
  this.syncView.hidden = true

  //创建切换按钮
  this.createButton("configButton","configButtonTapped:",targetView)
  MNButton.setConfig(this.configButton, 
    {color:"#457bd3",alpha:0.8,opacity:1.0,title:"Prompt",font:17,bold:true}
  )

  this.createButton("modelTab","modelTabTapped:",targetView)
  MNButton.setConfig(this.modelTab, 
    {color:"#9bb2d6",alpha:0.8,opacity:1.0,title:"Model",font:17,bold:true}
  )

  this.createButton("actionButton","actionButtonTapped:",targetView)
  MNButton.setConfig(this.actionButton, 
    {color:"#9bb2d6",alpha:0.8,opacity:1.0,title:"Action",font:17,bold:true}
  )

  this.createButton("syncConfig","syncConfigTapped:",targetView)
  MNButton.setConfig(this.syncConfig, 
    {color:"#9bb2d6",alpha:0.8,opacity:1.0,title:"Sync",font:17,bold:true}
  )

  this.createButton("advancedButton","advancedButtonTapped:",targetView)
  MNButton.setConfig(this.advancedButton, 
    {color:"#9bb2d6",alpha:0.8,opacity:1.0,title:"More",font:17,bold:true}
  )


  //创建各分页下的按钮



  //advanceView
  targetView = "advanceView"
  this.createButton("windowLocationButton","toggleWindowLocation:",targetView)
  MNButton.setConfig(this.windowLocationButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("orderButton","changeSearchOrder:",targetView)
  MNButton.setConfig(this.orderButton, {opacity: 1.0,color: "#457bd3", alpha: 0.8})
  
  this.creatTextView("knowledgeInput",targetView)

  this.createButton("saveKnowledgeButton","saveKnowledgeButtonTapped","advanceView")
  MNButton.setConfig(this.saveKnowledgeButton, {opacity: 1.0,color:"#9bb2d6",alpha:0.8,title:"Save Knowledge"})

  this.refreshView(targetView)


  //autoActionView

  targetView = "autoActionView"

  this.createButton("autoActionButton","toggleAutoAction:",targetView)
  this.createButton("onSelectionButton","toggleOnSelection:",targetView)
  this.createButton("onNoteButton","toggleOnNote:",targetView)
  this.createButton("onNewExcerptButton","toggleOnNewExcerpt:",targetView)
  this.createButton("newExcerptTagDetection","toggleNewExcerptTagDetection:",targetView)
  this.createButton("ignoreButton","toggleIgnoreShortText:",targetView)
  this.createButton("delayButton","changeDelay:",targetView)
  let color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
  for (let index = 0; index < 32; index++) {
    this["ColorButton"+index]   = UIButton.buttonWithType(0);
    this["ColorButton"+index].index = index
    this["ColorButton"+index].hidden = !chatAIConfig.getConfig("autoAction")
    if (index > 15) {
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index-16])
    }else{
      this.setColorButtonLayout(this["ColorButton"+index],"toggleColorConfig:",color[index])
    }
  }
  this.refreshView(targetView)

  this.autoActionButton.layer.opacity = 1.0

  //modelView

  targetView = "modelView"

  this.createButton("sourceButton","changeSource:",targetView)
  MNButton.setConfig(this.sourceButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("tunnelButton","changeTunnel:",targetView)
  MNButton.setConfig(this.tunnelButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  this.createButton("refreshButton","refreshKey:",targetView)
  MNButton.setConfig(this.refreshButton, {opacity:1.0,color:"#457bd3",alpha:0.8,title:"Refresh"})

  this.createButton("usageButton","refreshUsage:",targetView)
  this.usageButton.builtIn = true
  MNButton.setConfig(this.usageButton, {opacity:1.0,color:"#457bd3",alpha:0.8})

  
  this.createButton("saveCustomModels","saveCustomModels:","modelView")
  MNButton.setTitle(this.saveCustomModels, "Save")
  this.creatTextView("customModelInput","modelView")
  MNButton.setColor(this.saveCustomModels, "#457bd3",0.8)
  
  this.createButton("modelButton","changeModel:","modelView")
  MNButton.setColor(this.modelButton, "#457bd3",0.8)

  this.createButton("importSubscriptionButton","importFromSubscription:","modelView")
  MNButton.setTitle(this.importSubscriptionButton, "Import from subscription")
  MNButton.setColor(this.importSubscriptionButton, "#457bd3",0.8)

  this.createButton("customUsage","refreshUsage:","modelView")
  this.customUsage.builtIn = false
  MNButton.setConfig(this.customUsage, {title:"Usage:",color:"#457bd3",alpha:0.8})

  this.creatTextView("apiKeyInput","modelView")
  this.apiKeyInput.bounces = true
  this.apiKeyInput.editable = true

  this.createButton("pasteApiKeyButton","pasteApiKey:","modelView")
  MNButton.setConfig(this.pasteApiKeyButton, {opacity:1.0,color:"#9bb2d6",title:"Paste key"})

  this.createButton("saveApiKeyButton","saveApiKey:","modelView")
  MNButton.setConfig(this.saveApiKeyButton, {opacity:1.0,color:"#9bb2d6",title:"Save"})

  this.creatTextView("URLInput","modelView")

  this.createButton("pasteURLButton","pasteURL:","modelView")
  MNButton.setConfig(this.pasteURLButton, {opacity:1.0,color:"#9bb2d6",title:"Paste url"})

  this.createButton("saveURLButton","saveURL:","modelView")
  MNButton.setConfig(this.saveURLButton, {opacity:1.0,color:"#9bb2d6",title:"Save"})

  this.refreshView(targetView)

  //configView
  targetView = "configView"
  this.scrollview = UIScrollView.new()
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
  this.creatTextView("contextInput","configView")
  this.creatTextView("systemInput","configView")
  this.systemInput.hidden = true

  this.creatTextView("titleInput","configView","#9bb2d6")
  this.createButton("dynamicButton","toggleDynamic:","scrollview")



  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  // copyJSON(chatAIConfig.prompts)
  // copy(text)
  this.titleInput.contentInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.titleInput.textContainerInset = {top: 0,left: 0,bottom: 0,right: 0}
  this.createButton("funcButton","changeFunc:","configView")
  MNButton.setConfig(this.funcButton, {opacity:1.0,title:"Func"})

  this.createButton("promptModel","changePromptModel:","configView")
  MNButton.setConfig(this.promptModel, {opacity:1.0,title:"Model"})

  this.createButton("configReset","resetConfig:","configView")
  MNButton.setConfig(this.configReset, {opacity:1.0,title:"Reset"})

  this.createButton("saveButton","configSaveTapped:","configView")
  MNButton.setConfig(this.saveButton, {opacity:1.0,title:"Save"})

  this.createButton("deleteButton","configDeleteTapped:","configView")
  MNButton.setConfig(this.deleteButton, {opacity:1.0,title:"🗑"})

  this.createButton("newEntryButton","configAddTapped:","configView")
  MNButton.setConfig(this.newEntryButton, {opacity:1.0,title:"➕"})

  this.createButton("addVarButton","addVariable:","configView")
  MNButton.setConfig(this.addVarButton, {opacity:1.0,title:"➕"})

  this.createButton("contextButton","configContextTapped:","configView")
  MNButton.setConfig(this.contextButton, {opacity:1.0,title:"User",color:"#457bd3",alpha:0.8})

  this.createButton("SystemButton","configSystemTapped:","configView")
  MNButton.setConfig(this.SystemButton, {opacity:1.0,title:"System",color:"#9bb2d6",alpha:0.8})
  this.refreshView(targetView)

  //syncView
  targetView = "syncView"

  this.creatTextView("configNoteIdInput",targetView)
  this.configNoteIdInput.editable = false
  this.createButton("syncTimeButton","syncConfig:",targetView)
  MNButton.setConfig(this.syncTimeButton, {color:"#457bd3",alpha:0.8})
  
  this.createButton("exportConfigButton","exportConfig:",targetView)
  MNButton.setConfig(this.exportConfigButton, {title:"Export Config To Note",color:"#457bd3",alpha:0.8})

  this.createButton("importConfigButton","importConfig:",targetView)
  MNButton.setConfig(this.importConfigButton, {title:"Import Config From Note",color:"#457bd3",alpha:0.8})

  this.createButton("autoExportButton","toggleAutoExport:",targetView)
  MNButton.setConfig(this.autoExportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("autoImportButton","toggleAutoImport:",targetView)
  MNButton.setConfig(this.autoImportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("pasteConfigNoteButton","pasteConfigNoteId:",targetView)
  MNButton.setConfig(this.pasteConfigNoteButton, {title:"Paste",color:"#9bb2d6",alpha:0.8})

  this.createButton("clearConfigNoteButton","clearConfigNoteId:",targetView)
  MNButton.setConfig(this.clearConfigNoteButton, {title:"Clear",color:"#9bb2d6",alpha:0.8})

  this.createButton("focusConfigNoteButton","focusConfigNoteId:",targetView)
  MNButton.setConfig(this.focusConfigNoteButton, {title:"Focus",color:"#9bb2d6",alpha:0.8})

  this.refreshView(targetView)  


} catch (error) {
  MNUtil.showHUD(error)

}
}

/**
 * @this {chatglmController}
 * @param {string[]} names
 */
chatglmController.prototype.setButtonText = function (names,highlight) {
try {
  
    this.words = names
    // MNUtil.showHUD("count:"+names.length)
    names.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let buttonName = "nameButton"+index
      if (!this[buttonName]) {
        this.createButton(buttonName,"toggleSelected:","scrollview")
        // this[buttonName].index = index
        // MNUtil.showHUD("Create "+buttonName)
        this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this[buttonName].hidden = false
      this[buttonName].setTitleForState(chatAIConfig.prompts[word].title,0) 
      this[buttonName].id = word

      this[buttonName].isSelected = (word === highlight)
      MNButton.setColor(this[buttonName], (word === highlight) ? "#457bd3" : "#9bb2d6",0.8)
    })
    this.refreshLayout()
} catch (error) {
  MNUtil.showHUD(error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setTextview = function (name) {
      // let entries           =  NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
      let text  = chatAIConfig.prompts[name]
      this.titleInput.text= text.title
      this.contextInput.text = text.context?text.context:""
      if (!text.system) {
        text.system = ""
      }
      this.systemInput.text = text.system

}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshLayout = function () {
  if (!this.settingView) {return}
  this.dynamicButton.frame = MNUtil.genFrame(10,10,110,30)
  if (!this.configView.hidden) {
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 130
    let initY = 10
    let initL = 0
    this.locs = [];
    // MNUtil.copyJSON(this.words)
    // MNUtil.showHUD("words count:"+this.words.length)
    this.words.map((word,index)=>{
      if (!(word in chatAIConfig.prompts)) {
        return
      }
      let title = chatAIConfig.prompts[word].title
      let width = chatAIUtils.strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    // MNUtil.copyJSON(this.locs)
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        // MNUtil.showHUD("Hidden:"+"nameButton"+index)
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }
}

chatglmController.prototype.hideAllButton = function (frame) {
  // if (condition) {
    
  // }
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.maxButton.hidden = true
}
chatglmController.prototype.showAllButton = function (frame) {
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.maxButton.hidden = false
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.show = function (frame) {
try {
  MNUtil.studyView.bringSubviewToFront(this.view)
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.currentFrame
  let preOpacity = this.view.layer.opacity
  this.view.layer.opacity = 0.2
  // this.settingView.hidden = true
  // if (frame) {
  //   this.view.frame = frame
  //   this.currentFrame = frame
  // }
  this.view.hidden = false
  this.hideAllButton()

  MNUtil.animate(()=>{
    this.view.layer.opacity = preOpacity
    // this.view.frame = preFrame
    // this.currentFrame = preFrame
  }).then(()=>{
    try {
    this.view.layer.borderWidth = 0
    this.view.layer.opacity = 1.0
    // MNUtil.copy("123")
    this.showAllButton()
    this.settingView.hidden = false
    } catch (error) {
      MNUtil.showHUD(error)
    }
    // chatAIUtils.copyJSON(this.view.frame)
  })
  if (chatAIConfig.getConfig("autoImport")) {
    chatAIConfig.import(false)
  }

} catch (error) {
  MNUtil.showHUD("Error in show: "+error)
}
}
chatglmController.prototype.hide = function (frame) {
  MNUtil.studyView.bringSubviewToFront(chatAIUtils.addonBar)
  let preFrame = this.view.frame
  let preOpacity = this.view.layer.opacity
  let preCustom = this.custom
  this.hideAllButton()
  this.custom = false
  MNUtil.animate(()=>{
    this.view.layer.opacity = 0.2
  }).then(()=>{
    this.view.hidden = true;
    this.view.layer.opacity = preOpacity      
    this.view.frame = preFrame
    this.currentFrame = preFrame
    this.custom = preCustom
  })
}

chatglmController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

chatglmController.prototype.creatTextView = function (viewName,superview="view",color="#c0bfbf",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}

/**
 * 
 * @param {UIButton} button 
 * @param {*} targetAction 
 * @param {*} color 
 */
chatglmController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    button.layer.borderWidth = 2
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.autoActionView.addSubview(button);
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.fetch = async function (url,options = {}){
  return new Promise((resolve, reject) => {
    // UIApplication.sharedApplication().networkActivityIndicatorVisible = true
    const queue = NSOperationQueue.mainQueue()
    const request = chatAINetwork.initRequest(url, options)
    NSURLConnection.sendAsynchronousRequestQueueCompletionHandler(
      request,
      queue,
      (res, data, err) => {
        if (err.localizedDescription) reject(err.localizedDescription)
        // if (data.length() === 0) resolve({})
        const result = NSJSONSerialization.JSONObjectWithDataOptions(
          data,
          1<<0
        )
        if (NSJSONSerialization.isValidJSONObject(result)) resolve(result)
        resolve(result)
      }
    )
  })
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.genCardStructure = async function (noteid,OCR_enabled=false) {
  // let hasImage = false
  let cardStructure = {}
  let note = MNUtil.getNoteById(noteid)
  if (note.noteTitle && note.noteTitle !== "") {
    cardStructure.title = note.noteTitle
  }
  if (OCR_enabled && note.excerptPic && !note.textFirst) {
    cardStructure.excerpt = await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(note.excerptPic.paint))
    // hasImage = true
  }else if (chatAIUtils.noteHasExcerptText(note)){
    cardStructure.excerpt = note.excerptText
  }
  if (note.comments.length) {
    let comments = []
    for (let i = 0; i < note.comments.length; i++) {
      const comment = note.comments[i];
      switch (comment.type) {
        case "TextNote":
          if (/^marginnote\dapp:\/\//.test(comment.text)) {
          }else{
            comments.push(comment.text)
          }
          break
        case "HtmlNote":
          comments.push(comment.text)
          break
        case "LinkNote":
          if (OCR_enabled && comment.q_hpic && !note.textFirst) {
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.q_hpic.paint)))
          }else{
            comments.push(comment.q_htext)
          }
          break
        case "PaintNote":
          if (OCR_enabled && comment.paint){
            comments.push(await chatAINetwork.getTextOCR(MNUtil.getMediaByHash(comment.paint)))
          }
          break
        default:
          break
      }
    }
    if (comments.length === 1) {
      cardStructure.comment = comments[0]
    }else{
      cardStructure.comments = comments
    }
  }
  // MNUtil.copy("length:"+Object.keys(cardStructure).length)
  let keys = Object.keys(cardStructure)
  // 只有一个键时，不需要返回整个结构
  if (keys.length === 1) {
    return cardStructure[keys[0]]
  }
  return cardStructure
}

/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileContent = async function (fileObject){

  let file_id = await this.getFileId(fileObject)
  if (!file_id) {
    return undefined
  }
  if (this.fileContent[file_id]) {
    return JSON.stringify(this.fileContent[file_id],null,2)
  }
  MNUtil.showHUD("Get file content: "+fileObject.name)
  let key = chatAIConfig.config.moonshotKey
  if (!key) {
    MNUtil.showHUD("No Moonshot ApiKey!")
    return undefined
  }
  let url = `https://api.moonshot.cn/v1/files/${file_id}/content`
  let headers = {
      Authorization: "Bearer "+key,
      "Content-Type": "application/json"
  }
  try {
    const res = await this.fetch(url,
      {
        method: "Get",
        timeout: 60,
        headers: headers
      }
    )
    
    // res.file_type = "application/pdf"
    res.filename = fileObject.name
    this.fileContent[file_id] = res
    // copyJSON(res)
    return JSON.stringify(res,null,2);
  } catch (error) {
    // showHUD(error)
    // copy(error)
    return undefined
  }
}

/**
 * @this {chatglmController}
 * @param {{name:String,path:String,md5:String}} fileObject
 */
chatglmController.prototype.getFileId = async function (fileObject){
  let fileMd5 = fileObject.md5
  if (chatAIConfig.fileId[fileMd5]) {
    return chatAIConfig.fileId[fileMd5]
  }
  let key = chatAIConfig.config.moonshotKey
  if (!key) {
    MNUtil.showHUD("No Moonshot ApiKey!")
    return undefined
  }
  MNUtil.showHUD("Upload file: "+fileObject.name)
  let fileId = (await chatAINetwork.upload(fileObject.path,key)).id
  if (!fileId) {
    return undefined
  }
  chatAIConfig.fileId[fileMd5] = fileId
  chatAIConfig.save("MNChatglm_fileId")
  return fileId
}

/**
 * @this {chatglmController}
 * @param {String} text
 */
chatglmController.prototype.ask = async function (text,promptKey = chatAIConfig.currentPrompt){
    // showHUD(promptKey)
    let question = await this.getQuestion(promptKey)
    if (!question) {
      return
    }
    chatAIUtils.notifyController.currentPrompt = promptKey
    chatAIUtils.notifyController.text = text
    chatAIUtils.notifyController.ask(question)
    return question
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModel = function (source) {
  let modelNames = chatAIConfig.modelNames(source)
  // showHUD("message")
  switch (source) {
    case "ChatGLM":
      // modelNames = chatAIConfig.modelNames("ChatGLM")
      // modelNames = ["GLM-3-Turbo","GLM-4"]
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("chatglmModel")],0)
      break;
    case "Claude":
      // modelNames = chatAIConfig.modelNames("Claude")
      // modelNames = ["claude-3-haiku-20240307","claude-3-sonnet-20240229","claude-3-opus-20240229"]
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("claudeModel")],0)
      break;
    case "Gemini":
      // modelNames = chatAIConfig.modelNames("Gemini")
      // modelNames = ["gemini-pro","gemini-pro-vision","gemini-1.5-pro-latest"]
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("geminiModel")],0)
      break;
    case "ChatGPT":
      // modelNames = chatAIConfig.modelNames("ChatGPT")
      // if (chatAIConfig.config.customModel) {
      //   let customModels = chatAIConfig.config.customModel.split(",")
      //   modelNames = modelNames.concat(customModels)
      // }
      this.modelButton.setTitleForState(modelNames[chatAIConfig.config.model],0) 
      break;
    case "KimiChat":
      // modelNames = chatAIConfig.modelNames("KimiChat")
      this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("moonshotModel")],0) 
      break;
    case "Custom":
      if (chatAIConfig.config.customModel && chatAIConfig.config.customModel.trim() === "") {
        this.modelButton.setTitleForState("No model",0) 
      }else{
        // modelNames = chatAIConfig.config.customModel.split(",")
        this.modelButton.setTitleForState(modelNames[chatAIConfig.getConfig("customModelIndex")],0) 
      }
      break;
    default:
      break;
  }
  let viewFrame = this.view.bounds
  let width = viewFrame.width
  switch (source) {
    case "ChatGLM":
      this.modelButton.frame = MNUtil.genFrame(10,140,width-20,40)
      // this.save
      break;
    case "Claude":
      this.modelButton.frame = MNUtil.genFrame(10,140,width-20,40)
      // this.save
      break;
    case "Gemini":
      this.modelButton.frame = MNUtil.genFrame(10,140,width-20,40)
      // this.save
      break;
    case "KimiChat":
      this.modelButton.frame = MNUtil.genFrame(10,140,width-20,40)
      break;
    case "ChatGPT":
      this.modelButton.frame = MNUtil.genFrame(10,185,185,40)
      this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(10, 230, width-95, 50)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      this.importSubscriptionButton.frame = MNUtil.genFrame(10, 285, width-20, 35)
      break;
    case "Custom":
      this.modelButton.frame = MNUtil.genFrame(10,185,width-20,40)
      this.saveCustomModels.frame = MNUtil.genFrame(width-80,230,70,50)
      this.customModelInput.frame = MNUtil.genFrame(10, 230, width-95, 50)
      if (chatAIConfig.config.customModel) {
        this.customModelInput.text = chatAIConfig.config.customModel
      }else{
        this.customModelInput.text = "Custom model"
      }
      break;
    default:
      break;
  }
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.switchView = function (targetView) {
  let allViews = ["configView", "syncView", "advanceView", "modelView", "autoActionView"]
  let allButtons = ["configButton","syncConfig", "advancedButton", "modelTab", "actionButton"]
  allViews.forEach((k,index) => {
    let isTargetView = k === targetView
    this[k].hidden = !isTargetView
    this[allButtons[index]].backgroundColor = MNUtil.hexColorAlpha(isTargetView?"#457bd3":"#9bb2d6",0.8)
  })
  self.refreshView(targetView)
}

/**
 * @this {chatglmController}
 */
chatglmController.prototype.refreshView = function (targetView) {
try {
  

  switch (targetView) {
    case "advanceView":
      
      this.knowledgeInput.text = chatAIConfig.knowledge
      let locInd = chatAIConfig.config.notifyLoc
      let locNames = ["Left","Right"]
      MNButton.setTitle(this.windowLocationButton, "Notification: "+locNames[locInd])
      MNButton.setTitle(this.orderButton, chatAIConfig.getOrderText())
      break;
    case "modelView":
      this.sourceButton.setTitleForState("Source: "+chatAIConfig.getConfig("source"),0)
      let tunnels = ['Tunnel: 1️⃣','Tunnel: 2️⃣','Tunnel: 3️⃣','Tunnel: 4️⃣']
      this.tunnelButton.setTitleForState(tunnels[chatAIConfig.getConfig("tunnel")],0)
      let usage  = chatAIConfig.usage
      this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
      this.setModel(chatAIConfig.config.source)
      this.setModelButton(chatAIConfig.config.source)
      break;
    case "configView":
      if (chatAIConfig.getConfig("dynamic")) {
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#fd3700",alpha:0.8,title:"Dynamic: ✅"})
      }else{
        MNButton.setConfig(this.dynamicButton, {opacity:1.0,color:"#ff9375",alpha:0.8,title:"Dynamic: ❌"})
      }
      let text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      if (!text) {
        chatAIConfig.setCurrentPrompt(chatAIConfig.config.promptNames[0])
        text  = chatAIConfig.prompts[chatAIConfig.currentPrompt]
      }
      this.contextInput.text = text.context?text.context:""
      this.titleInput.text = text.title
      // MNUtil.copyJSON(chatAIConfig.config)
      this.setButtonText(chatAIConfig.config.promptNames,chatAIConfig.currentPrompt)
      this.setTextview(chatAIConfig.currentPrompt)
      break;
    case "syncView":
      this.configNoteIdInput.text = chatAIConfig.getConfig("syncNoteId")
      MNButton.setTitle(this.autoExportButton, "Auto Export: "+(chatAIConfig.getConfig("autoExport")?"✅":"❌"))
      MNButton.setTitle(this.autoImportButton, "Auto Import: "+(chatAIConfig.getConfig("autoImport")?"✅":"❌"))
      let dateObj = new Date(chatAIConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(this.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())

      break;
    case "autoActionView":
      MNButton.setTitle(this.ignoreButton, "Ignore short text: "+(chatAIConfig.getConfig("ignoreShortText")?"✅":"🚫"))
      if (chatAIConfig.getConfig("ignoreShortText")) {
        MNButton.setColor(this.ignoreButton, "#457bd3", 0.8)
      }else{
        MNButton.setColor(this.ignoreButton, "#9bb2d6", 0.8)
      }
      let autoAction = chatAIConfig.getConfig("autoAction")
      MNButton.setTitle(this.delayButton, "Delay: "+chatAIConfig.config.delay+"s")
      MNButton.setColor(this.delayButton, "#457bd3",0.8)
      MNButton.setColor(this.autoActionButton, autoAction?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.autoActionButton, autoAction?"Auto Action: ✅":"Auto Action: ❌")
      this.onSelectionButton.hidden = !autoAction
      this.onNewExcerptButton.hidden = !autoAction
      this.newExcerptTagDetection.hidden = !autoAction
      this.onNoteButton.hidden = !autoAction
      this.ignoreButton.hidden = !autoAction
      this.delayButton.hidden = !autoAction
      let onSelection = chatAIConfig.config.onSelection
      MNButton.setColor(this.onSelectionButton, onSelection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onSelectionButton, onSelection?"On Selection: ✅":"On Selection: ❌")
      let onNote = chatAIConfig.config.onNote
      MNButton.setColor(this.onNoteButton, onNote?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNoteButton, onNote?"On Note: ✅":"On Note: ❌")
      let onNewExcerpt = chatAIConfig.config.onNewExcerpt
      MNButton.setColor(this.onNewExcerptButton, onNewExcerpt?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.onNewExcerptButton, onNewExcerpt?"On New Excerpt: ✅":"On New Excerpt: ❌")
      let newExcerptTagDetection = chatAIConfig.config.newExcerptTagDetection
      MNButton.setColor(this.newExcerptTagDetection, newExcerptTagDetection?"#457bd3":"#9bb2d6", 0.8)
      MNButton.setTitle(this.newExcerptTagDetection, newExcerptTagDetection?"Tag detection: ✅":"Tag detection: ❌")
      for (let index = 0; index < 32; index++) {
        this["ColorButton"+index].hidden = !chatAIConfig.config.autoAction
      }
      MNUtil.refreshAddonCommands()
      break;
    default:
      break;
  }
} catch (error) {
  MNUtil.showHUD("Error in refreshView: "+error)
}
}
/**
 * @this {chatglmController}
 */
chatglmController.prototype.setModelButton = function (source) {
  if (source == "ChatGPT") {
    this.URLInput.hidden = false
    this.pasteURLButton.hidden = false
    this.saveURLButton.hidden = false
    this.saveCustomModels.hidden = false
    this.customModelInput.hidden = false
    this.customUsage.hidden = false
    if (typeof subscriptionConfig === 'undefined') {
      this.importSubscriptionButton.hidden = true
    }else{
      this.importSubscriptionButton.hidden = !chatAIUtils.checkSubscribe(false)
    }
  }else{
    this.URLInput.hidden = true
    this.pasteURLButton.hidden = true
    this.saveURLButton.hidden = true
    this.saveCustomModels.hidden = true
    this.customModelInput.hidden = true
    this.customUsage.hidden = true
    this.importSubscriptionButton.hidden = true
  }
  if (source == "Built-in") {
    this.apiKeyInput.hidden = true
    this.pasteApiKeyButton.hidden = true
    this.saveApiKeyButton.hidden = true
    this.modelButton.hidden = true
    this.tunnelButton.hidden = false
    this.refreshButton.hidden = false
    this.usageButton.hidden = false
  }else{
    this.apiKeyInput.hidden = false
    this.pasteApiKeyButton.hidden = false
    this.saveApiKeyButton.hidden = false
    this.modelButton.hidden = false
    this.tunnelButton.hidden = true
    this.refreshButton.hidden = true
    this.usageButton.hidden = true
  }
  let config = chatAIConfig.getConfigFromSource(source)
  this.apiKeyInput.text = config.key
  switch (source) {
      case "ChatGPT":
        let URL = chatAIConfig.config.url
        if (URL === "") {
          URL = `https://api.openai.com`
        }
        this.URLInput.text = URL
        break;
      case "Built-in":
        let usage  = chatAIConfig.usage
        this.usageButton.setTitleForState("Usage: "+usage.usage+"/100",0)
        break;
      case "Custom":
        this.URLInput.text = chatAIConfig.config.customUrl ?? ""
        this.usageButton.hidden = true
        this.pasteURLButton.hidden = false
        this.saveURLButton.hidden = false
        this.URLInput.hidden = false
        this.customModelInput.hidden = false
        this.saveCustomModels.hidden = false
        break;
      default:
        break;
    }
}
/** @type {UITextView} */
chatglmController.prototype.contextInput